package com.connor.jd.plm.dialogs;

import java.awt.Component;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import com.teamcenter.rac.kernel.TCSession;

public class MyTreeCellRenderer extends DefaultTreeCellRenderer {
	private TCSession session;

	public MyTreeCellRenderer(TCSession session) {
		this.session = session;
	}

	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf,
			int row, boolean hasFocus) {

		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);

		setText(value.toString());

		if (sel) {
			setForeground(getTextSelectionColor());
		} else {
			setForeground(getTextNonSelectionColor());
		}

		DefaultMutableTreeNode node = (DefaultMutableTreeNode) value;
		String str = node.toString();
		if (!"".equals(str)) {
//			session.search(arg0, arg1, arg2)
		}

		return this;
	}
}
