package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Objects;

import javax.swing.DefaultCellEditor;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;

import com.connor.jd.plm.beans.ComponentBean;
import com.connor.jd.plm.beans.JG;
import com.connor.jd.plm.table.DatePickerCellEditor;
import com.connor.jd.plm.table.TCTableUtil;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetType;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.stylesheet.AbstractRendering;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.services.rac.core.DataManagementService;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateIn;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateResponse;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

public class CSJHForm extends AbstractRendering {

	TCComponent form;
	DefaultTableModel model;
	TCSession session;
	TCComponentItemRevision itemR;
	private static Connection con = null;
	private static PreparedStatement ps = null;
	private static ResultSet rs = null;
	private ObservableList<ComponentBean> componentData = FXCollections.observableArrayList();
	String[] propNames = new String[] { "jd2_syxh", "jd2_symd", "jd2_wtry", "jd2_syxm", "jd2_syts", "jd2_syzq",
			"jd2_syfy", "jd2_jhrc", "jd2_jhrc1", "jd2_sjrc", "jd2_sjrc1", "jd2_syzt", "jd2_syjg", "jd2_sycs",
			"jd2_syry", "jd2_csbg", "jd2_bz" };
	private JLabel label3;
	private List<Integer> editable = new ArrayList<Integer>();
	private Map<String, JG> res;
	private Map<Integer, String> rowNo;
	private JTable table;
	private boolean againAllow;

	public CSJHForm(TCComponent form) throws Exception {
		super();
		this.form = form;
		session = (TCSession) AIFUtility.getCurrentApplication().getSession();
		System.out.println("");
		loadRendering();
	}

	int index = 1;

	@Override
	public void loadRendering() throws TCException {
//		try {
//			con = DBConnectionUtil.dbConn("infodba", "infodba");
//			String sqlString = "select * from JD2_Component";
//			if (con == null) {
//				Alert alert = new Alert(AlertType.ERROR, "ʧ");
//				alert.show();
//			} else {
//				ps = con.prepareStatement(sqlString);
//				rs = ps.executeQuery();
//				while (rs.next()) {
//					ComponentBean comBean = new ComponentBean();
//					// System.out.println("һݣ" + rs.getString(1));
//					comBean.setType(rs.getString(1));
//					comBean.setProject(rs.getString(2));
//					comBean.setTime(rs.getString(3));
//					comBean.setNumber(String.valueOf(rs.getInt(4)));
//					comBean.setCost(String.valueOf(rs.getDouble(5)));
//					comBean.setCompId(rs.getInt(6));
//					comBean.setAddId(0);
//					comBean.setStage(0);// մݿȡ
//					componentData.add(comBean);
//				}
//			}
//		} catch (Exception e) {
//			e.printStackTrace();
//		} finally {
//			if (rs != null) {
//				try {
//					rs.close();
//				} catch (SQLException e1) {
//					e1.printStackTrace();
//				}
//			}
//			if (ps != null) {
//				try {
//					ps.close();
//				} catch (SQLException e1) {
//					e1.printStackTrace();
//				}
//			}
//			if (con != null) {
//				try {
//					con.close();
//				} catch (SQLException e1) {
//					e1.printStackTrace();
//				}
//			}
//		}
		this.setPreferredSize(new Dimension(1200, 250));
		TCComponent[] tables = form.getTCProperty("jd2_csjh").getReferenceValueArray();
		AIFComponentContext[] contexts = form.whereReferenced();
		for (int i = 0; i < contexts.length; i++) {
			if (contexts[i].getComponent() instanceof TCComponentItemRevision) {
				try {
					itemR = (TCComponentItemRevision) contexts[i].getComponent();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		}
		String[] info = new String[] { "NO", "ʵͺ", "ʵĿ", "ίԱ", "ʵĿ", "ʵ̨", "ʵ", "", "ƻʼ", "ƻ",
				"ʵʿʼ", "ʵ", "ʵ״̬", "ʵ", "_ʵ", "ʵԱ", "Ա", "ע" };
		model = new DefaultTableModel(info, 0);
		JComboBox<String> testStage = new JComboBox();
		JComboBox<String> testResult = new JComboBox();
		String[] stageInfo = { "", "", "", " " };
		for (int i = 0; i < stageInfo.length; i++) {
			testStage.addItem(stageInfo[i]);
		}
		testResult.addItem("ϸ");
		testResult.addItem("ϸ");
		testResult.addItem(" ");
		for (int i = 0; i < tables.length; i++) {
			String[] temp = new String[18];
			temp[0] = Integer.toString(index++);
			String[] props = tables[i].getProperties(propNames);
			for (int j = 0; j < props.length; j++) {
				temp[j + 1] = props[j];
			}
			model.addRow(temp);
		}

		TCComponentItemRevision[] revs = itemR.getItem().getReleasedItemRevisions();
		Comparator<TCComponent> leatestRevisionComparator = new Comparator<TCComponent>() {

			@Override
			public int compare(TCComponent o1, TCComponent o2) {
				// TODO Auto-generated method stub
				try {
					return o1.getProperty("item_revision_id").compareTo(o2.getProperty("item_revision_id"));
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return 0;
			}
		};
		Arrays.parallelSort(revs, leatestRevisionComparator);
		if (revs.length > 0) {
			List<Map<String, String>> dataMap = TCTableUtil.getTableMapList(
					(TCComponentForm) revs[revs.length - 1].getRelatedComponent("IMAN_master_form_rev"), "jd2_csjh",
					propNames);
			List<String> realNoList = new ArrayList<String>();
			for (Map<String, String> tempMap : dataMap) {
				realNoList.add(tempMap.get("jd2_syxm") + "," + tempMap.get("jd2_sycs"));
			}
			for (int i = 0; i < tables.length; i++) {
				if (realNoList.contains(tables[i].getProperty("jd2_syxm") + "," + tables[i].getProperty("jd2_sycs"))) {
					editable.add(i);
				}
			}
		}

		// Ŀǰ汾ǷΪ·һ汾
		List<String> releasedObjectString = new ArrayList<String>();
		for (int i = 0; i < revs.length; i++) {
			releasedObjectString.add(revs[i].getProperty("object_string"));
		}
		if (revs.length > 0) {
			if (!releasedObjectString.contains(itemR.getProperty("object_string"))) {
				TCComponent[] allRev = itemR.getItem().getRelatedComponents("revision_list");
				Arrays.parallelSort(allRev, leatestRevisionComparator);
				for (int i = 0; i < allRev.length; i++) {
					if (allRev[i].getProperty("object_string")
							.equals(revs[revs.length - 1].getProperty("object_string")) && i + 1 < allRev.length) {
						if (itemR.getProperty("object_string").equals(allRev[i + 1].getProperty("object_string"))) {
							againAllow = true;
							break;
						}
					}
				}
			}
		}

//		for (int i = 0; i < componentData.size(); i++) {
//			// for (int j = 0; j < tables.length; j++) {
//			String project = componentData.get(i).getProject();
//			String number = componentData.get(i).getNumber();
//			String time = componentData.get(i).getTime();
//			String cost = componentData.get(i).getCost();
////				if (!project.equals(tables[j].getProperty("jd2_syxm"))
////						&& !number.equals(tables[j].getProperty("jd2_syts"))
////						&& !time.equals(tables[j].getProperty("jd2_syzq"))
////						&& !cost.equals(tables[j].getProperty("jd2_syfy"))) {
//			String[] temp = new String[16];
//			temp[0] = Integer.toString(index++);
//			temp[4] = componentData.get(i).getProject();
//			temp[5] = componentData.get(i).getNumber();
//			temp[6] = componentData.get(i).getTime();
//			temp[7] = componentData.get(i).getCost();
//			model.addRow(temp);
////				}
////			}
//		}

		table = new JTable(model) {
			@Override
			public boolean isCellEditable(int row, int column) {
				if (column == 3 || column == 4 || column == 5 || column == 6 || column == 7 || column == 16
						|| column == 14 || editable.contains(row))
					return false;
				else
					return true;
			}
		};

		table.addPropertyChangeListener(e -> {
			if (e.getPropertyName().equals("tableCellEditor")) {
				// System.out.println("change");
			}
		});
		for (int i = 0; i < 16; i++) {
			table.getColumn(table.getColumnName(i)).setMinWidth(100);
		}

		DefaultCellEditor dce1 = new DefaultCellEditor(testStage) {

			int row;

			@Override
			public Component getTableCellEditorComponent(JTable paramJTable, Object paramObject, boolean paramBoolean,
					int paramInt1, int paramInt2) {
				// TODO Auto-generated method stub

				row = paramInt1;
				return super.getTableCellEditorComponent(paramJTable, paramObject, paramBoolean, paramInt1, paramInt2);
			}

			@Override
			public Object getCellEditorValue() {

				Object obj = super.getCellEditorValue();
				if ("".equals(obj.toString())) {
//					editable.add(row);
				} else {
					if (editable.contains(row)) {
						editable.remove(row);
					}
				}
				return obj;
			}
		};

		DefaultCellEditor dce2 = new DefaultCellEditor(testResult) {
			JTable t;
			int row;
			int num;

			@Override
			public Component getTableCellEditorComponent(JTable paramJTable, Object paramObject, boolean paramBoolean,
					int paramInt1, int paramInt2) {
				// TODO Auto-generated method stub
				t = paramJTable;
				row = paramInt1;
				String str = t.getValueAt(row, 14) == null ? "" : t.getValueAt(row, 14).toString();
				num = Objects.equals(str, "") ? 0 : Integer.parseInt(str);
				return super.getTableCellEditorComponent(paramJTable, paramObject, paramBoolean, paramInt1, paramInt2);
			}

			@Override
			public Object getCellEditorValue() {
				// TODO Auto-generated method stub

				Object obj = super.getCellEditorValue();

				if (res.containsKey(rowNo.get(row))) {
					if (num >= res.get(rowNo.get(row)).getTimes()) {
						res.put(rowNo.get(row), new JG(row, num, obj.toString()));
					}
				} else {
					res.put(rowNo.get(row), new JG(row, num, obj.toString()));
				}

				boolean flag = false;
				for (Entry<String, JG> entry : res.entrySet()) {
					if ("ϸ".equals(entry.getValue().getJg())) {
						flag = true;
						break;
					}
				}
				if (flag) {
					label3.setText("ۣϸ");
				} else {
					label3.setText("ۣϸ");
				}
				return obj;
			}
		};
		DatePickerCellEditor dpce = new DatePickerCellEditor(new JTextField());
		DefaultCellEditor deafult = new DefaultCellEditor(new JTextField());
		for (int i = 0; i < table.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i).setCellEditor(deafult);
		}
		table.getColumn(table.getColumnName(8)).setCellEditor(dpce);
		table.getColumn(table.getColumnName(9)).setCellEditor(dpce);
		table.getColumn(table.getColumnName(10)).setCellEditor(dpce);
		table.getColumn(table.getColumnName(11)).setCellEditor(dpce);
		table.getColumn(table.getColumnName(12)).setCellEditor(dce1);
		table.getColumn(table.getColumnName(13)).setCellEditor(dce2);
		table.setRowHeight(25);
		table.setAutoscrolls(true);
		table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		table.getTableHeader().setReorderingAllowed(false);
		if (form.isCheckedOut()) {
			table.setEnabled(true);
		} else {
			table.setEnabled(false);
		}
		JPanel panelLable = new JPanel();
		JLabel label = new JLabel("ܼƣ");
		JLabel label2 = new JLabel();
		Double allcost = 0.0;
		for (int i = 0; i < model.getRowCount(); i++) {
			String value = (String) model.getValueAt(i, 7);
			if (value.equals(""))
				value = "0";
			allcost += Double.valueOf(value);
		}
		label2.setText(allcost + "Ԫ");

		label3 = new JLabel("ۣ");
		res = new HashMap<String, JG>();
		rowNo = new HashMap<Integer, String>();
		String no;
		String jg;
		for (int i = 0; i < tables.length; i++) {
			no = tables[i].getProperty("jd2_no");
			rowNo.put(i, no);
			jg = tables[i].getProperty("jd2_syjg");
			int times = Integer.parseInt(
					Objects.equals(tables[i].getProperty("jd2_sycs"), "") ? "0" : tables[i].getProperty("jd2_sycs"));
			if ("".equals(tables[i].getProperty("jd2_syzt"))) {
//				editable.add(i);
			}
			if (res.containsKey(no)) {
				if (times >= res.get(no).getTimes()) {
					editable.add(res.get(no).getRow());
					res.put(no, new JG(i, times, jg));
				}
			} else {
				res.put(no, new JG(i, times, jg));
			}
		}
		boolean notEmpty = false;
		boolean qualified = true;
		for (Entry<String, JG> entry : res.entrySet()) {
//			System.out.println(entry.getKey() + entry.getValue().getRow() + entry.getValue().getJg()
//					+ entry.getValue().getTimes());
			if (!"".equals(entry.getValue().getJg().trim())) {
				notEmpty = true;
			}
			if ("ϸ".equals(entry.getValue().getJg())) {
				qualified = false;
				break;
			}
		}
		if (notEmpty && !qualified) {
			label3.setText("ۣϸ");
		} else if (notEmpty) {
			label3.setText("ۣϸ");
		}

		panelLable.add(label);
		panelLable.add(label2);
		panelLable.add(label3);

		JPanel panel = new JPanel();
		JScrollPane pane = new JScrollPane(table);
		GridBagLayout gbl = new GridBagLayout();
		JPanel bottom = new JPanel(gbl);
		GridBagConstraints gbs = new GridBagConstraints();
		gbs.anchor = GridBagConstraints.SOUTHEAST;
		gbs.fill = GridBagConstraints.HORIZONTAL;
		gbs.insets = new Insets(10, 20, 5, 10);
		gbs.weighty = 0.2;
		gbs.gridheight = 1;
		gbs.gridwidth = GridBagConstraints.REMAINDER;
		gbs.weightx = 1;
		JButton testButton = new JButton("Աϴ");
		gbl.setConstraints(testButton, gbs);
		JButton huizongButton = new JButton("ܽϴ");
		gbl.setConstraints(huizongButton, gbs);
		JButton againButton = new JButton("ٴ");
		gbl.setConstraints(againButton, gbs);
		bottom.add(testButton);
		bottom.add(huizongButton);
		bottom.add(againButton);

		setLayout(new BorderLayout());
		panel.add(pane, BorderLayout.CENTER);

		JPanel root = new JPanel(new BorderLayout());
		root.add(bottom, BorderLayout.EAST);
		root.add(panelLable, BorderLayout.SOUTH);
		root.add(pane, BorderLayout.CENTER);
		JScrollPane jsp = new JScrollPane(root);
		add(jsp, BorderLayout.CENTER);
		testButton.addActionListener(e -> {
			JFileChooser chooser = new JFileChooser();
			chooser.setDialogTitle("ѡϴĲԱ");
			FileFilter filter = new FileNameExtensionFilter("Excel(.xlsx,.xls,.xlsm)", "xlsx", "xls", "xlsm");// ļֻгJPGGIFʽͼƬ
			chooser.setFileFilter(filter);
			chooser.showOpenDialog(null);
			File file = chooser.getSelectedFile();
			if (file != null) {
				String filePath = file.getPath();
				String fileName = file.getName();
				String filename = fileName.substring(0, fileName.lastIndexOf("."));
				System.out.println(filePath);
				System.out.println(fileName);
				int row = table.getSelectedRow();
				String value = model.getValueAt(row, 16) == null ? "" : model.getValueAt(row, 16).toString();
				if (value.equals("")) {
					try {
						TCComponentItemType itemtype = (TCComponentItemType) session.getTypeComponent("JD2_GTCSBG");
						String itemId = itemtype.getNewID();
						String itemRev = itemtype.getNewRev(null);
						TCComponentItem item = itemtype.create(itemId, itemRev, "JD2_GTCSBG", fileName, "", null);
						itemR.add("JD2_CSBG", item);
						TCComponentDatasetType datasetType = (TCComponentDatasetType) session
								.getTypeComponent("Dataset");
						String msType = "";
						if (filePath.endsWith(".xls")) {
							msType = "MSExcel";
						} else if (filePath.endsWith(".xlsx") || filePath.endsWith(".xlsm")) {
							msType = "MSExcelX";
						}
						TCComponentDataset datasetMSExcelX = datasetType.create(filename, "", msType);
						datasetMSExcelX.setFiles(new String[] { filePath }, new String[] { "excel" });// Σļ·Ӧãtext
						item.getLatestItemRevision().add("IMAN_specification", datasetMSExcelX);
						model.setValueAt(item.getProperty("current_id"), row, 16);
					} catch (TCException e1) {
						e1.printStackTrace();
					}
				} else {
					// ӵݼ
					boolean exist = false;
					try {
						TCComponent[] tcc = itemR.getTCProperty("JD2_CSBG").getReferenceValueArray();
						for (int i = 0; i < tcc.length; i++) {
							if (value.equals(tcc[i].getProperty("current_id"))) {
								exist = true;
								TCComponentItem item = (TCComponentItem) tcc[i];
								TCComponent[] tccitem = item.getLatestItemRevision().getTCProperty("IMAN_specification")
										.getReferenceValueArray();
								TCComponentDataset dataset = (TCComponentDataset) tccitem[0];
								dataset.setFiles(new String[] { file.getPath() }, new String[] { "excel" });
								dataset.setProperty("object_name", filename);
								item.setProperty("object_name", filename);
								item.getLatestItemRevision().setProperty("object_name", filename);
							}
						}
						if (!exist) {
							try {
								TCComponentItemType itemtype = (TCComponentItemType) session
										.getTypeComponent("JD2_GTCSBG");
								String itemId = itemtype.getNewID();
								String itemRev = itemtype.getNewRev(null);
								TCComponentItem item = itemtype.create(itemId, itemRev, "JD2_GTCSBG", fileName, "",
										null);
								itemR.add("JD2_CSBG", item);
								TCComponentDatasetType datasetType = (TCComponentDatasetType) session
										.getTypeComponent("Dataset");
								String msType = "";
								if (filePath.endsWith(".xls")) {
									msType = "MSExcel";
								} else if (filePath.endsWith(".xlsx") || filePath.endsWith(".xlsm")) {
									msType = "MSExcelX";
								}
								TCComponentDataset datasetMSExcelX = datasetType.create(filename, "", msType);
								datasetMSExcelX.setFiles(new String[] { filePath }, new String[] { "excel" });// Σļ·Ӧãtext
								item.getLatestItemRevision().add("IMAN_specification", datasetMSExcelX);
								model.setValueAt(item.getProperty("current_id"), row, 16);
							} catch (TCException e1) {
								e1.printStackTrace();
							}
						}
					} catch (TCException e1) {
						e1.printStackTrace();
					}
				}

			}

		});
		huizongButton.addActionListener(e -> {
			int row = table.getSelectedRow();
			String value = (String) model.getValueAt(row, 16);
			JFileChooser chooser = new JFileChooser();
			chooser.setDialogTitle("ѡϴĻܽ");
			FileFilter filter = new FileNameExtensionFilter("Excel(.xlsx,.xls,.xlsm),PPTʾĸ(.ppt,.pptx)", "xlsx",
					"xls", "xlsm", "ppt", "pptx");// ļֻгJPGGIFʽͼƬ
			chooser.setFileFilter(filter);
			chooser.showOpenDialog(null);
			File file = chooser.getSelectedFile();
			TCComponentItemRevision parentRev = null;
			try {
				AIFComponentContext[] aifs = itemR.getItem().whereReferenced();
				for (AIFComponentContext aif : aifs) {
					if (aif.getComponent().getType().equals("JD2_GTSYWTSRevision")) {
						parentRev = (TCComponentItemRevision) aif.getComponent();
						System.out.println("JD2_GTSYWTSRevision check");
					}
				}
			} catch (TCException e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
			if (file != null) {
				String filePath = file.getPath();
				String fileName = file.getName();
				String filename = fileName.substring(0, fileName.lastIndexOf("."));
				System.out.println(filePath);
				System.out.println(fileName);
				if (value.equals("")) {
					try {
						TCComponentItemType itemtype = (TCComponentItemType) session.getTypeComponent("JD2_GTCSBG");
						String itemId = itemtype.getNewID();
						String itemRev = itemtype.getNewRev(null);
						TCComponentItem item = itemtype.create(itemId, itemRev, "JD2_GTCSBG", fileName, "", null);
						parentRev.add("JD2_CSBGHZ", item);
						TCComponentDatasetType datasetType = (TCComponentDatasetType) session
								.getTypeComponent("Dataset");
						String msType = "";
						String fileType = "";
						if (filePath.endsWith(".xls")) {
							msType = "MSExcel";
							fileType = "excel";
						} else if (filePath.endsWith(".xlsx") || filePath.endsWith(".xlsm")) {
							msType = "MSExcelX";
							fileType = "excel";
						} else if (filePath.endsWith(".ppt")) {
							msType = "MSPowerPoint";
							fileType = "powerpoint";
						} else if (filePath.endsWith(".pptx")) {
							msType = "MSPowerPointX";
							fileType = "powerpoint";
						}
						TCComponentDataset datasetMSExcelX = datasetType.create(filename, "", msType);
						datasetMSExcelX.setFiles(new String[] { filePath }, new String[] { fileType });// Σļ·Ӧãtext
						item.getLatestItemRevision().add("IMAN_specification", datasetMSExcelX);
					} catch (TCException e1) {
						e1.printStackTrace();
					}
				} else {
					// ӵݼ
					boolean exist = false;
					try {
						TCComponent[] tcc = itemR.getTCProperty("JD2_CSBGHZ").getReferenceValueArray();
						for (int i = 0; i < tcc.length; i++) {
							if (value.equals(tcc[i].getProperty("current_id"))) {
								exist = true;
								TCComponentItem item = (TCComponentItem) tcc[i];
								TCComponent[] tccitem = item.getLatestItemRevision().getTCProperty("IMAN_specification")
										.getReferenceValueArray();
								TCComponentDataset dataset = (TCComponentDataset) tccitem[0];
								dataset.setFiles(new String[] { file.getPath() }, new String[] { "excel" });
								dataset.setProperty("object_name", filename);
								item.setProperty("object_name", filename);
								item.getLatestItemRevision().setProperty("object_name", filename);
							}
						}
						if (!exist) {
							try {
								TCComponentItemType itemtype = (TCComponentItemType) session
										.getTypeComponent("JD2_GTCSBG");
								String itemId = itemtype.getNewID();
								String itemRev = itemtype.getNewRev(null);
								TCComponentItem item = itemtype.create(itemId, itemRev, "JD2_GTCSBG", fileName, "",
										null);
								parentRev.add("JD2_CSBGHZ", item);
								TCComponentDatasetType datasetType = (TCComponentDatasetType) session
										.getTypeComponent("Dataset");
								String msType = "";
								if (filePath.endsWith(".xls")) {
									msType = "MSExcel";
								} else if (filePath.endsWith(".xlsx") || filePath.endsWith(".xlsm")) {
									msType = "MSExcelX";
								}
								TCComponentDataset datasetMSExcelX = datasetType.create(filename, "", msType);
								datasetMSExcelX.setFiles(new String[] { filePath }, new String[] { "excel" });// Σļ·Ӧãtext
								item.getLatestItemRevision().add("IMAN_specification", datasetMSExcelX);
							} catch (TCException e1) {
								e1.printStackTrace();
							}
						}
					} catch (TCException e1) {
						e1.printStackTrace();
					}

				}
			}
		});

		againButton.addActionListener(e -> {
			String[] temp = new String[16];
			int num = Integer.valueOf((String) model.getValueAt(table.getSelectedRow(), 0)) + 1;
			// temp[0] = String.valueOf(num);
			temp[1] = (String) model.getValueAt(table.getSelectedRow(), 1);
			temp[2] = (String) model.getValueAt(table.getSelectedRow(), 2);
			temp[3] = (String) model.getValueAt(table.getSelectedRow(), 3);
			temp[4] = (String) model.getValueAt(table.getSelectedRow(), 4);
			temp[5] = (String) model.getValueAt(table.getSelectedRow(), 5);
			temp[6] = (String) model.getValueAt(table.getSelectedRow(), 6);
			temp[7] = (String) model.getValueAt(table.getSelectedRow(), 7);
			String chishu = (String) model.getValueAt(table.getSelectedRow(), 14);
			if ("".equals(chishu)) {
				chishu = "0";
				System.out.println(chishu);
			}
			if (chishu == null) {
				chishu = "0";
			}
			int cishuNum = Integer.valueOf(chishu);
			boolean isNotLatest = false;
			Object obj;
			String xm;
			int num1;
			if (!againAllow) {
				MessageBox.post("ǰİ汾·汾һδ汾ٴ", "ʾ", MessageBox.WARNING);
				return;
			}
			for (int i = 0; i < table.getRowCount(); i++) {
				xm = (obj = table.getValueAt(i, 4)) == null ? "" : obj.toString();
				if (temp[4].equals(xm)) {
					num1 = Integer.parseInt((obj = table.getValueAt(i, 14)) == null ? "0" : obj.toString());
					if (cishuNum < num1) {
						isNotLatest = true;
						break;
					}
				}
			}
			if (isNotLatest) {
				MessageBox.post("ѡµһʵ", "ʾ", MessageBox.WARNING);
				return;
			}
//			boolean allowFlag = false;
//			if (againAllowFlow == null) {
//				try {
//					againAllowFlow = JDMethodUtil.getPrefStrArray("jd_csjh_again_allow", session)[1];// 
//					TCComponent[] comps = form.getRelatedComponents("fnd0AllWorkflows");
//					if (comps.length > 0) {
//						String flowName;
//						for (TCComponent comp : comps) {
//							flowName = comps[0].getProperty("object_name");
//							System.out.println(flowName);
//							if (flowName.equals(againAllowFlow)) {
//								allowFlag = true;
//								break;
//							}
//						}
//					} else {
//						MessageBox.post("޷ٴ飬ȷϵǰĿ괦", "ʾ", MessageBox.WARNING);
//						return;
//					}
//				} catch (ArrayIndexOutOfBoundsException ex) {
//					// TODO: handle exception
//					ex.printStackTrace();
//					MessageBox.post("ѡ\"jd_csjh_again_allow\"ô", "", MessageBox.ERROR);
//					return;
//				} catch (TCException e1) {
//					// TODO Auto-generated catch block
//					e1.printStackTrace();
//				}
//			}
//			if (!allowFlag) {
//				MessageBox.post("޷ٴ飬Ŀ״̬\"jd_csjh_again_allow\"", "ʾ", MessageBox.WARNING);
//				return;
//			}
			temp[14] = String.valueOf(cishuNum + 1);
//				temp[16] = (String) model.getValueAt(table.getSelectedRow(), 16);
			temp[15] = (String) model.getValueAt(table.getSelectedRow(), 15);
			model.insertRow(table.getSelectedRow() + 1, temp);
			for (int i = table.getSelectedRow() + 1; i < model.getRowCount(); i++) {

				model.setValueAt(String.valueOf(num++), i, 0);
			}
			Double allcost2 = 0.0;
			for (int i = 0; i < model.getRowCount(); i++) {
				String value = (String) model.getValueAt(i, 7);
				if (value.equals(""))
					value = "0";
				allcost2 += Double.valueOf(value);
			}
			label2.setText(allcost2 + "Ԫ");
			editable.add(table.getSelectedRow());
			for (int i = 0; i < editable.size(); i++) {
				if (editable.get(i) >= (table.getSelectedRow() + 1)) {
					editable.set(i, editable.get(i) + 1);
				}
			}
			for (Entry<String, JG> entry : res.entrySet()) {
				if (entry.getValue().getRow() >= (table.getSelectedRow() + 1)) {
					res.get(entry.getKey()).setRow(entry.getValue().getRow() + 1);
				}
			}
			rowNo.put(table.getSelectedRow() + 1, rowNo.get(table.getSelectedRow()));

		});

		table.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (table.getSelectedColumn() == 16) {
					if (e.getClickCount() == 2) {
						System.out.println("˫");
						int selectedRow = table.getSelectedRow(); // ѡ
						String value = (String) model.getValueAt(selectedRow, 16);
						if (value == null)
							value = "";
						if (!value.equals("")) {
							try {
								TCComponent[] result = session.search(" ID", new String[] { " ID" },
										new String[] { value });
								TCComponentItem item = (TCComponentItem) result[0];
								TCComponent[] tccitem = item.getLatestItemRevision().getTCProperty("IMAN_specification")
										.getReferenceValueArray();
								TCComponentDataset dataset = (TCComponentDataset) tccitem[0];
								dataset.open();
							} catch (Exception e1) {
								e1.printStackTrace();
							}
						}
					}
				}

			}
		});

	}

	@Override
	public void saveRendering() {
		try {
			List<TCComponent> c = new ArrayList<TCComponent>();
			if (table.getSelectedColumn() >= 0) {
				table.getColumnModel().getColumn(table.getSelectedColumn()).getCellEditor().stopCellEditing();
			}
//			TCComponent[] com = form.getTCProperty("sf6_EplanBOMLineTable").getReferenceValueArray();
//			for (int j = 0; j < com.length; j++) {
//				c.add(com[j]);
//			}
			DataManagementService service = DataManagementService
					.getService((TCSession) AIFUtility.getCurrentApplication().getSession());
			CreateIn[] newIn = new CreateIn[model.getRowCount()];
			for (int i = 0; i < model.getRowCount(); i++) {
				CreateIn in = new CreateIn();
				Map<String, String> propMap = new HashMap<String, String>();
				propMap.put("jd2_no", rowNo.get(i));
				for (int j = 0; j < propNames.length; j++) {
					propMap.put(propNames[j],
							model.getValueAt(i, j + 1) == null ? "" : model.getValueAt(i, j + 1).toString());
				}
				// System.out.println("prop:" + propMap);
				in.data.boName = "JD2_CSJHTABLE";
				in.data.stringProps = propMap;
				newIn[i] = in;
			}
			try {
				CreateResponse response = service.createObjects(newIn);
				System.out.println(response.serviceData.sizeOfCreatedObjects());
				if (response.serviceData.sizeOfCreatedObjects() > 0) {
					// System.out.println("CreateResponse");
					int length = response.serviceData.sizeOfCreatedObjects();
					for (int i = 0; i < length; i++) {
						c.add(response.output[i].objects[0]);
					}

				}
			} catch (Exception e) {
				e.printStackTrace();
			}

			form.getTCProperty("jd2_csjh").setReferenceValueArray(c.toArray(new TCComponent[c.size()]));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public boolean isRenderingModified() {
		// TODO Auto-generated method stub
		return form.isCheckedOut();
	}

}
