package com.connor.jd.plm.handlers;

import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.connor.jd.plm.dialogs.TransformDesignToPartDialog;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.TCTypeService;
import com.teamcenter.rac.util.ButtonLayout;

public class TransformDesignToPartHandler extends AbstractHandler {
	private StringBuffer errorMsgSb;
	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		try {
			errorMsgSb=new StringBuffer();
			System.out.println("111");
			final AbstractAIFApplication app= AIFUtility.getCurrentApplication();
			TCSession session=(TCSession) app.getSession();
			final String[] types=session.getPreferenceService().getStringValues("connor_wl_type");
			TCComponentItemRevision rev = (TCComponentItemRevision) app.getTargetComponent();
			TCTypeService service = session.getTypeService();
			TCComponentBOMWindowType bomwindow = (TCComponentBOMWindowType) service.getTypeComponent("BOMWindow");
			TCComponentBOMWindow window = bomwindow.create(null);
			final TCComponentBOMLine topBomline = window.setWindowTopLine(rev.getItem(), rev, null, null);
			checkBomRef(topBomline,types);
			checkBomLine(topBomline,types);
			System.out.println("step:-2------------------");
			if (!errorMsgSb.toString().equals("")) {
				final JFrame sFrame = new JFrame("ȷ϶Ի");
				sFrame.setSize(350, 200);
				JLabel title = new JLabel("                                         ");
				JTextArea area = new JTextArea(4, 30);
				area.setText("" + errorMsgSb.append("޹ϣȷҪ˳!"));
				area.setWrapStyleWord(true);
				area.setLineWrap(true);
				area.setEditable(false);
				JButton okButton = new JButton("ȷ");
				okButton.addMouseListener(new MouseAdapter() {
					@Override
					public void mouseClicked(MouseEvent e) {
						// TODO Auto-generated method stub
						try {
							sFrame.dispose();
							new TransformDesignToPartDialog(app, topBomline,types);
						} catch (Exception e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}

					}
				});
				JButton celButton = new JButton("˳");
				celButton.addMouseListener(new MouseAdapter() {
					@Override
					public void mouseClicked(MouseEvent e) {
						// TODO Auto-generated method stub
						sFrame.dispose();
						return;
					}
				});
				JPanel panel = new JPanel(new BorderLayout());
				panel.add(area, BorderLayout.CENTER);
				panel.add(title, BorderLayout.NORTH);
				JPanel buttonPanel = new JPanel(new ButtonLayout());
				buttonPanel.add("1.1.left,top", okButton);
				buttonPanel.add("1.2.left,top", new Label("       "));
				buttonPanel.add("1.3.left,top", celButton);
				JPanel rootPanel = new JPanel(new BorderLayout());
				rootPanel.add(buttonPanel, BorderLayout.SOUTH);
				rootPanel.add(panel, BorderLayout.CENTER);
				sFrame.setLayout(new BorderLayout());
				sFrame.add(rootPanel);
				sFrame.setLocationRelativeTo(null);
				sFrame.setVisible(true);
				sFrame.setResizable(false);
			} else {
				new Thread(new TransformDesignToPartDialog(app, topBomline,types)).start();;
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	/**
	 * bombom
	 * @param line
	 * @throws TCException
	 */
	public void checkBomLine(TCComponentBOMLine line,String[] types) throws TCException {
		if (line == null) {
			return;
		}
		AIFComponentContext[] children = line.getChildren();
		for (int i = 0; i < children.length; i++) {
			TCComponentBOMLine childLine = (TCComponentBOMLine) children[i].getComponent();
			checkBomRef(childLine,types);
			checkBomLine(childLine,types);
		}

	}

	// ûй
	public void checkBomRef(TCComponentBOMLine line,String[] types) {
		try {
			if (line == null) {
				return;
			}
			if (line.getItemRevision().isTypeOf("PartRevision")) {
				//# 
			} else {
				System.out.println("check");
				AIFComponentContext[] aifContext = line.getItemRevision().whereReferencedByTypeRelation(
						types, new String[] { "TC_Is_Represented_By" });
				if (aifContext == null || aifContext.length == 0) {
					this.errorMsgSb.append(line.getProperty("object_string") + ",");
				}
			}
		} catch (

		TCException e) {
			e.printStackTrace();
		}
	}

}
