package com.connor.jd.plm.beans;

import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentItemRevision;

public class BOMManageTableBean {

	private String parentString;
	private String childString;
	private TCComponentItemRevision parentRev;
	private TCComponentItemRevision childRev;
	private TCComponentBOMLine parentLine;
	private TCComponentBOMLine childLine;

	public BOMManageTableBean(String parentString, String childString, TCComponentItemRevision parentRev,
			TCComponentItemRevision childRev, TCComponentBOMLine parentLine, TCComponentBOMLine childLine) {
		super();
		this.parentString = parentString;
		this.childString = childString;
		this.parentRev = parentRev;
		this.childRev = childRev;
		this.parentLine = parentLine;
		this.childLine = childLine;
	}

	public String getParentString() {
		return parentString;
	}

	public void setParentString(String parentString) {
		this.parentString = parentString;
	}

	public String getChildString() {
		return childString;
	}

	public void setChildString(String childString) {
		this.childString = childString;
	}

	public TCComponentItemRevision getParentRev() {
		return parentRev;
	}

	public void setParentRev(TCComponentItemRevision parentRev) {
		this.parentRev = parentRev;
	}

	public TCComponentItemRevision getChildRev() {
		return childRev;
	}

	public void setChildRev(TCComponentItemRevision childRev) {
		this.childRev = childRev;
	}

	public TCComponentBOMLine getParentLine() {
		return parentLine;
	}

	public void setParentLine(TCComponentBOMLine parentLine) {
		this.parentLine = parentLine;
	}

	public TCComponentBOMLine getChildLine() {
		return childLine;
	}

	public void setChildLine(TCComponentBOMLine childLine) {
		this.childLine = childLine;
	}

}
