package com.connor.jd.plm.beans;

import java.util.ArrayList;
import java.util.List;

public class CustomLovBean {
	private List<CustomLovBean> sub = new ArrayList<CustomLovBean>();
	public String displayName = "";

	public CustomLovBean(String displayName) {
		super();
		this.displayName = displayName;
	}

	public CustomLovBean(String displayName, String[] subArray) {
		super();
		this.displayName = displayName;
		translateArrayToSub(subArray);
	}

	public void translateArrayToSub(String[] subArray) {
		for (int i = 0; i < subArray.length; i++) {
			sub.add(new CustomLovBean(subArray[i]));
		}
	}

	public List<CustomLovBean> getSub() {
		return sub;
	}

	public boolean hasChild() {
		return sub.size() != 0;
	}

	public void addSub(CustomLovBean clb) {
		sub.add(clb);
	}
}
