package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.DefaultTableCellRenderer;

import com.connor.jd.plm.table.CTMap;
import com.connor.jd.plm.table.CTable;
import com.connor.jd.plm.table.JCheckPanel;
import com.connor.jd.plm.table.JRadioPanel;
import com.connor.jd.plm.table.MyCellEditor;
import com.connor.jd.plm.table.MyCellEditor1;
import com.connor.jd.plm.table.MyCellEditor2;
import com.connor.jd.plm.table.MyComboBoxRenderer;
import com.connor.jd.plm.table.TCTableUtil;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetType;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentICO;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.ics.ICSProperty;
import com.teamcenter.rac.stylesheet.AbstractRendering;

public class SampleConfirmationForm extends AbstractRendering {
	private AbstractAIFApplication app = AIFUtility.getCurrentApplication();
	private TCComponentForm form;
	private TCSession session;
	private CardLayout cl = new CardLayout();
	private JPanel center = null;
	private JPopupMenu menu = new JPopupMenu();
	private JPopupMenu menu2 = new JPopupMenu();
	private JPopupMenu menu3 = new JPopupMenu();
	private JPanel confirmPanel = new JPanel();
	private JPanel examinePanel = new JPanel();
	private CTMap model;
	private CTMap model2;
	private CTMap model3;
	private CTable table;
	private CTable table2;
	private CTable table3;
	private int top = 13;// ͷ
	private int bottom;// м䲿ֽ
	private int end = 1;// β+1
	private int top2 = 4;
	private int bottom2;
	private int end2 = 16;
	private Map<String, String> prop;
	private Map<String, int[]> general;
	private Map<String, int[]> general3;
	private List<String> disableEdit;
	private List<String> disableEdit3;
	private Map<String, int[]> picMap = new HashMap<String, int[]>();// ͼƬ;
	private Map<String, int[]> fileMap = new HashMap<String, int[]>();// ļ;
	private List<String> disableEdit2;
	private JRadioPanel yssl;
	private JCheckPanel mqjd;
	private JComboBox<String> bpdj;
	private JComboBox<String> fl;
	private JComboBox<String> zt;
	private JComboBox<String> jued;
	private String[] colNames = { "jd2_no", "jd2_gg", "jd2_gg1", "jd2_gc", "jd2_gc1", "jd2_1", "jd2_2", "jd2_3",
			"jd2_4", "jd2_5", "jd2_6", "jd2_7", "jd2_8", "jd2_9", "jd2_10", "jd2_min", "jd2_max", "jd2_jg" };
	private String[] colNames1 = { "jd2_ctq1", "jd2_ctq2", "jd2_ctq3", "jd2_ctq4", "jd2_ctq5", "jd2_ctq6", "jd2_ctq7",
			"jd2_ctq8" };
	private String[] colNames2 = { "jd2_no", "jd2_ctq1", "jd2_ctq2", "jd2_ctq3", "jd2_ctq4", "jd2_ctq5", "jd2_ctq6",
			"jd2_ctq7", "jd2_ctq8" };
	private String[] colNames3 = { "jd2_ctq1", "jd2_ctq2", "jd2_ctq3", "jd2_ctq4", "jd2_ctq5", "jd2_ctq6", "jd2_ctq7",
			"jd2_ctq8" };
	private Map<String, String> jgItems = new HashMap<String, String>();
	private JMenuItem addP;
	private JMenuItem delP;
	private JMenuItem addR;
	private JMenuItem insertR;
	private JMenuItem delR;
	private JMenuItem addR2;
	private JMenuItem insertR2;
	private JMenuItem delR2;
	private JMenuItem addF;
	private JMenuItem delF;
	private TCComponentItemRevision rev;
	private String[][] dataStore = new String[8][13];

	public SampleConfirmationForm(TCComponent arg0) throws Exception {
		super(arg0);

		if (arg0 instanceof TCComponentForm) {
			this.form = (TCComponentForm) arg0;
			this.session = (TCSession) app.getSession();
			loadRendering();
		}
	}

	@Override
	public void loadRendering() throws TCException {
		jgItems.put("ϸ", "0");
		jgItems.put("ܾ", "1");
		jgItems.put("", "2");
		jgItems.put("ͼֽ", "3");
		jgItems.put(" ", null);
		AIFComponentContext[] aifs = form.whereReferenced();
		for (AIFComponentContext aif : aifs) {
			if ("JD2_GTYPQRDRevision".equals(aif.getComponent().getType())) {
				rev = (TCComponentItemRevision) aif.getComponent();
				break;
			}
		}

		setLayout(new BorderLayout());
		JPanel root = new JPanel(new BorderLayout());
		root.setPreferredSize(new Dimension(800, 600));
		root.setBorder(new EmptyBorder(0, 0, 0, 25));
		// ͷ
		JPanel buttons = new JPanel(new FlowLayout(FlowLayout.LEFT));
		JButton confirm = new JButton("Ʒȷϵ");
		JButton examine = new JButton("CTQ");

		confirm.addActionListener(confirm());
		examine.addActionListener(examine());
		buttons.add(confirm);
		buttons.add(examine);

		// 
		center = new JPanel(cl);

		// ȷϵ
		confirmPanel.setBorder(BorderFactory.createLineBorder(Color.black, 1));
		confirmPanel.setLayout(new BorderLayout());
		confirmPanel.setPreferredSize(new Dimension(800, 600));

		// 
		model = new CTMap(30, 20);
		bottom = model.getRowCount() - end;
		initModel();

		table = new CTable(model) {
			@Override
			public boolean isCellEditable(int row, int col) {
				if (isEditorDisable(disableEdit, row, col)) {
					return false;
				}
				return true;
			}
		};
		table.setRowHeight(25);
		table.setBorder(BorderFactory.createLineBorder(Color.black));
		table.getColumnModel().getColumn(0).setPreferredWidth(40);
		table.getColumnModel().getColumn(1).setPreferredWidth(60);
		table.getColumnModel().getColumn(2).setPreferredWidth(50);
		table.getColumnModel().getColumn(3).setPreferredWidth(50);
		table.getColumnModel().getColumn(4).setPreferredWidth(50);
		table.getColumnModel().getColumn(5).setPreferredWidth(60);
		table.getColumnModel().getColumn(6).setPreferredWidth(60);
		for (int i = 7; i < model.getColumnCount() - 1; i++) {
			table.getColumnModel().getColumn(i).setPreferredWidth(45);
		}
		table.getColumnModel().getColumn(model.getColumnCount() - 1).setPreferredWidth(80);
		DefaultTableCellRenderer tcr1 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
					boolean hasFocus, int row, int column) {
				// TODO Auto-generated method stub

				if (value instanceof JPanel) {
					return (JPanel) value;
				}
				if (value instanceof JComboBox) {
					return (JComboBox<String>) value;
				}

				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(), 0);
					maxPreferredHeight = Math.max(maxPreferredHeight, getPreferredSize().height);
				}
				setBackground(Color.white);
//				if(points1.contains(new Point(row,column)))
//					setForeground(new Color(0,0,255));
//				else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};
		tcr1.setHorizontalAlignment(SwingConstants.CENTER);
		table.setDefaultRenderer(Object.class, tcr1);
		for (int i = 0; i < model.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i).setCellEditor(new MyCellEditor(new JTextField(), top, end, bottom));
		}
		table.addMouseListener(rightClick());

		model3 = new CTMap(13, 20);
		initModel3();
		table3 = new CTable(model3) {
			@Override
			public boolean isCellEditable(int row, int col) {
				if (isEditorDisable(disableEdit3, row, col)) {
					return false;
				}
				return true;
			}
		};
		table3.setRowHeight(25);
		table3.setBorder(BorderFactory.createLineBorder(Color.black));
		table3.getColumnModel().getColumn(0).setPreferredWidth(40);
		table3.getColumnModel().getColumn(1).setPreferredWidth(60);
		table3.getColumnModel().getColumn(2).setPreferredWidth(50);
		table3.getColumnModel().getColumn(3).setPreferredWidth(50);
		table3.getColumnModel().getColumn(4).setPreferredWidth(50);
		table3.getColumnModel().getColumn(5).setPreferredWidth(60);
		table3.getColumnModel().getColumn(6).setPreferredWidth(60);
		for (int i = 7; i < model3.getColumnCount() - 1; i++) {
			table3.getColumnModel().getColumn(i).setPreferredWidth(45);
		}
		table3.getColumnModel().getColumn(model3.getColumnCount() - 1).setPreferredWidth(80);
		DefaultTableCellRenderer tcr3 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
					boolean hasFocus, int row, int column) {
				// TODO Auto-generated method stub

				if (value instanceof JLabel) {
					JLabel label = (JLabel) value;
					if (isSelected) {
						label.setForeground(Color.WHITE);
						label.setBackground(new Color(0xff0078D7));
						label.setOpaque(true);
					} else {
						label.setForeground(new Color(0xff0078D7));
						label.setBackground(Color.WHITE);
						label.setOpaque(true);
					}
					return label;
				}
				if (value instanceof JComboBox) {
					return (JComboBox<String>) value;
				}

				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(), 0);
					maxPreferredHeight = Math.max(maxPreferredHeight, getPreferredSize().height);
				}
				setBackground(Color.white);
//				if(points1.contains(new Point(row,column)))
//					setForeground(new Color(0,0,255));
//				else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());

				return this;
			}

		};
		tcr3.setHorizontalAlignment(SwingConstants.CENTER);
		table3.setDefaultRenderer(Object.class, tcr3);
		for (int i = 0; i < model3.getColumnCount(); i++) {
			table3.getColumnModel().getColumn(i).setCellEditor(new MyCellEditor2(new JTextField()));
		}
		table3.addMouseListener(rightClick3());

		// ӳ
		prop = form.getProperties();
		AIFComponentContext[] parents = rev.getItem().whereReferenced();
		TCComponentItemRevision parentRev = null;
		for (AIFComponentContext aif : parents) {
			try {
				System.out.println(aif.getComponent().getProperty("object_string"));
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (aif.getComponent() instanceof TCComponentItemRevision) {
				parentRev = (TCComponentItemRevision) aif.getComponent();
			}
		}
		if (parentRev != null) {
			String partName = parentRev.getProperty("object_name");
			System.out.println(partName);
			if (prop.containsKey("jd2_ljm")) {
				form.setProperty("jd2_ljm", partName);
			}
			String materialCode = parentRev.getProperty("item_id");
			System.out.println(materialCode);
			if (prop.containsKey("jd2_wlbm")) {
				form.setProperty("jd2_wlbm", materialCode);
			}
			TCComponent[] drawings = parentRev.getReferenceListProperty("TC_Is_Represented_By");
			if (drawings != null && drawings.length > 0) {
				TCComponentItemRevision drawingRev = (TCComponentItemRevision) drawings[0];
				String drawingId = drawingRev.getProperty("item_id");
				System.out.println(drawingId);
				if (prop.containsKey("jd2_th")) {
					form.setProperty("jd2_th", drawingId);
				}
			}
			if (parentRev.getClassificationObjects() != null && parentRev.getClassificationObjects().length > 0) {
				TCComponentICO ico = parentRev.getClassificationObjects()[0];
				ICSProperty[] parentICSProps = ico.getICSProperties(true);
				for (int i = 0; i < parentICSProps.length; i++) {
					if (parentICSProps[i].getId() == 1050) {
						if (prop.containsKey("jd2_ljywm")) {
							form.setProperty("jd2_ljywm", parentICSProps[i].getValue());
						}
					}
					if (parentICSProps[i].getId() == 1058) {
						if (prop.containsKey("jd2_gg")) {
							form.setProperty("jd2_gg", parentICSProps[i].getValue());
						}
					}
				}
			}
		}

		// д
		prop = form.getProperties();
		for (Entry<String, int[]> entry : general.entrySet()) {
			if (prop.containsKey(entry.getKey())) {
				model.setValueAt(prop.get(entry.getKey()), entry.getValue()[0], entry.getValue()[1]);
			} else {
				model.setValueAt("", entry.getValue()[0], entry.getValue()[1]);
				System.out.println("ԡ" + entry.getKey() + "δҵ");
			}
		}

		for (Entry<String, int[]> entry : general3.entrySet()) {
			if (prop.containsKey(entry.getKey())) {
				model3.setValueAt(prop.get(entry.getKey()), entry.getValue()[0], entry.getValue()[1]);
			} else {
				model3.setValueAt("", entry.getValue()[0], entry.getValue()[1]);
				System.out.println("ԡ" + entry.getKey() + "δҵ");
			}
		}
		if (prop.containsKey("jd2_yssl")) {
			yssl.setSelected(prop.get("jd2_yssl"));
		} else {
			System.out.println("ԡjd2_ysslδҵ");
		}
		if (prop.containsKey("jd2_mqjd")) {
			mqjd.setSelected(prop.get("jd2_mqjd"));
		} else {
			System.out.println("ԡjd2_mqjdδҵ");
		}

		for (Entry<String, int[]> entry : picMap.entrySet()) {
			int row = entry.getValue()[0];
			int col = entry.getValue()[1];
			if (prop.containsKey(entry.getKey())) {
				TCComponent comp = null;
				try {
					if (!"".equals(prop.get(entry.getKey()))) {
						comp = session.stringToComponent(prop.get(entry.getKey()));
						TCComponentDataset dataset = (TCComponentDataset) comp;
						String temp = System.getenv("temp");
						System.out.println(temp);
						String[] types = dataset.getProperty("ref_names").split(",");
						System.out.println(Arrays.toString(types));
						System.out.println(Arrays.toString(dataset.getFileNames(types[0])));
						File img = dataset.getFiles(types[0], temp)[0];
						System.out.println(img.getPath());

						ImageIcon icon = new ImageIcon(img.getPath());

						int[] arr = model3.getSpan(row, col);
						System.out.println("row:" + arr[0] + ",col:" + arr[1]);
						icon.setImage(icon.getImage().getScaledInstance(
								table3.getColumnModel().getColumn(col).getPreferredWidth() * arr[1],
								table3.getRowHeight() * arr[0], Image.SCALE_SMOOTH));
						JLabel label = new JLabel();
						label.setLayout(new FlowLayout(FlowLayout.CENTER));
						label.setIcon(icon);
						label.setHorizontalAlignment(SwingConstants.CENTER);
						label.addMouseListener(showImg(img.getPath()));
						label.setToolTipText(dataset.getUid());
						model3.setValueAt(label, row, col);
					} else {
						model3.setValueAt(new JLabel(""), row, col);
					}
				} catch (Exception e) {
					model3.setValueAt(new JLabel(""), row, col);
					e.printStackTrace();
				}

			} else {
				model3.setValueAt(new JLabel(""), row, col);
				System.out.println("ԡ" + entry.getKey() + "δҵ");
			}
		}

		for (Entry<String, int[]> entry : fileMap.entrySet()) {
			int row = entry.getValue()[0];
			int col = entry.getValue()[1];
			if (prop.containsKey(entry.getKey())) {
				TCComponent comp = null;
				try {
					if (!"".equals(prop.get(entry.getKey()))) {
						comp = session.stringToComponent(prop.get(entry.getKey()));
						TCComponentDataset dataset = (TCComponentDataset) comp;
						String temp = System.getenv("temp");
						System.out.println(temp);
						String[] types = dataset.getProperty("ref_names").split(",");
						System.out.println(Arrays.toString(types));
						System.out.println(Arrays.toString(dataset.getFileNames(types[0])));
						File img = dataset.getFiles(types[0], temp)[0];
						System.out.println(img.getPath());

						int[] arr = model3.getSpan(row, col);
						System.out.println("row:" + arr[0] + ",col:" + arr[1]);
						JLabel label = new JLabel();
						label.setLayout(new FlowLayout(FlowLayout.CENTER));
						label.setForeground(new Color(0xff0078D7));
						label.setText(img.getName());
						label.setHorizontalAlignment(SwingConstants.CENTER);
						label.addMouseListener(showFile(dataset));
						label.setToolTipText(dataset.getUid());
						model3.setValueAt(label, row, col);
					} else {
						model3.setValueAt(new JLabel(""), row, col);
					}
				} catch (Exception e) {
					model3.setValueAt(new JLabel(""), row, col);
					e.printStackTrace();
				}

			} else {
				model3.setValueAt(new JLabel(""), row, col);
				System.out.println("ԡ" + entry.getKey() + "δҵ");
			}
		}

		if (prop.containsKey("jd2_ypqrdtable")) {
			String[][] tableRows = TCTableUtil.getTableRows(form, "jd2_ypqrdtable", colNames);
			System.out.println(Arrays.deepToString(tableRows));

			for (int i = 0; i < tableRows.length; i++) {
				for (int ii = 0; ii < tableRows[0].length; ii++) {
					if (i + top + 2 > bottom) {
						int num = Integer.parseInt(model.getValueAt(bottom, 0).toString());
						model.insertRow(bottom);
						model.setValueAt(num + 1, bottom, 0);
						model.combine(new int[] { bottom }, new int[] { 2, 3, 4 });
						bottom = model.getRowCount() - end;
					}
					if (ii == tableRows[0].length - 1) {
						JComboBox<String> jgComBox = new JComboBox<String>();
						jgComBox.setRenderer(new MyComboBoxRenderer());
						for (Entry<String, String> entry : jgItems.entrySet()) {
							jgComBox.addItem(entry.getKey());
						}
						jgComBox.setSelectedItem(tableRows[i][ii]);
						model.setValueAt(jgComBox, i + top + 2, ii + 2);
					} else {
						model.setValueAt(tableRows[i][ii], i + top + 2, ii > 2 ? ii + 2 : ii);
					}
				}
			}
		} else {
			System.out.println("ԡjd2_ypqrdtableδҵ");
		}

		JPanel inner = new JPanel(new BorderLayout());
		inner.add(table, BorderLayout.CENTER);
		inner.add(table3, BorderLayout.SOUTH);

//		ScrollPane confirmScrollPanel1 = new ScrollPane();
//		confirmScrollPanel1.add(inner);
		JScrollPane confirmScrollPanel1 = new JScrollPane(inner);
		confirmPanel.add(confirmScrollPanel1, BorderLayout.CENTER);

		// 
		examinePanel.setBorder(BorderFactory.createLineBorder(Color.black, 1));
		examinePanel.setLayout(new BorderLayout());

		model2 = new CTMap(49, 10);
		bottom2 = model2.getRowCount() - end2;
		disableEdit2 = new ArrayList<String>();
		model2.setValueAt("SPL No", 0, 0);
		disableEdit2.add("0,0");
		model2.combine(new int[] { 0, 1, 2, 3 }, new int[] { 0 });
		model2.setValueAt(" SPEC", 0, 1);
		disableEdit2.add("0,1");
		model2.combine(new int[] { 0, 1 }, new int[] { 1 });
		for (int i = 0; i < 8; i++) {
			model2.setValueAt("CTQ<" + (i + 1) + ">", 0, i + 2);
			disableEdit2.add("0," + (i + 2));
		}
		model2.setValueAt("LOW", 2, 1);
		disableEdit2.add("2,1");
		model2.setValueAt("UP", 3, 1);
		disableEdit2.add("3,1");

		for (int i = top2; i < model2.getRowCount(); i++) {
			model2.setValueAt(i - top2 + 1, i, 0);
			disableEdit2.add(i + ",0");
			model2.combine(new int[] { i }, new int[] { 0, 1 });
		}
		model2.setValueAt("MIN", bottom2 + 1, 0);
		model2.setValueAt("MAX", bottom2 + 2, 0);
		model2.setValueAt("R", bottom2 + 3, 0);
		model2.setValueAt("׼ƫ", bottom2 + 4, 0);
		model2.setValueAt("ƽ", bottom2 + 5, 0);
		model2.setValueAt("X,BAR-3S", bottom2 + 6, 0);
		model2.setValueAt("X,BAR+3S", bottom2 + 7, 0);
		model2.setValueAt("CP", bottom2 + 8, 0);
		model2.setValueAt("Cpu", bottom2 + 9, 0);
		model2.setValueAt("Cpl", bottom2 + 10, 0);
		model2.setValueAt("CPK", bottom2 + 11, 0);
		model2.setValueAt("SU Ԥⲻ", bottom2 + 12, 0);
		model2.setValueAt("SL Ԥⲻ", bottom2 + 13, 0);
		model2.setValueAt("Ԥⲻ(PPM)", bottom2 + 14, 0);
		model2.setValueAt("", bottom2 + 15, 0);

		table2 = new CTable(model2) {
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			@Override
			public boolean isCellEditable(int row, int col) {
				if (isEditorDisable(disableEdit2, row, col)) {
					return false;
				}
				return true;
			}
		};
		table2.setRowHeight(25);
		table2.setBorder(BorderFactory.createLineBorder(Color.black));
		for (int i = 0; i < model2.getColumnCount(); i++) {
			table2.getColumnModel().getColumn(i).setPreferredWidth(80);
		}
		DefaultTableCellRenderer tcr2 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
					boolean hasFocus, int row, int column) {
				// TODO Auto-generated method stub
				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(), 0);
					maxPreferredHeight = Math.max(maxPreferredHeight, getPreferredSize().height);
				}
				setBackground(Color.white);
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};
		tcr2.setHorizontalAlignment(SwingConstants.CENTER);
		table2.setDefaultRenderer(Object.class, tcr2);
		MyCellEditor1[] editor1 = new MyCellEditor1[model2.getColumnCount()];
		for (int i = 0; i < model2.getColumnCount(); i++) {
			editor1[i] = new MyCellEditor1(new JTextField(), top2, end2, bottom2);
			table2.getColumnModel().getColumn(i).setCellEditor(editor1[i]);
		}
		table2.addMouseListener(rightClick2());
		examinePanel.add(table2, BorderLayout.CENTER);
		if (prop.containsKey("jd2_ctq1")) {
			String[][] tableRows = TCTableUtil.getTableRows(form, "jd2_ctq1", colNames1);
			System.out.println(Arrays.deepToString(tableRows));
			for (int i = 0; i < tableRows.length; i++) {
				for (int ii = 0; ii < tableRows[0].length; ii++) {
					model2.setValueAt(tableRows[i][ii], i + 1, ii + 2);
					if (i == 1) {
						if (!"".equals(tableRows[i][ii])) {
							editor1[ii + 2].setLow(Double.parseDouble(tableRows[i][ii]));
							editor1[ii + 2].setCnt(editor1[ii + 2].getCnt() + 1);
						}
					}
					if (i == 2) {
						if (!"".equals(tableRows[i][ii])) {
							editor1[ii + 2].setUp(Double.parseDouble(tableRows[i][ii]));
							editor1[ii + 2].setCnt(editor1[ii + 2].getCnt() + 1);
						}
					}
				}
			}
		}
		if (prop.containsKey("jd2_ctq2")) {
			String[][] tableRows = TCTableUtil.getTableRows(form, "jd2_ctq2", colNames2);
			System.out.println(Arrays.deepToString(tableRows));
			for (int i = 0; i < tableRows.length; i++) {
				for (int ii = 0; ii < tableRows[0].length; ii++) {
					if (i + top2 > bottom2) {
						int num = Integer.parseInt(model2.getValueAt(bottom2, 0).toString());
						model2.insertRow(++bottom2);
						model2.setValueAt(num + 1, bottom2, 0);
						model2.combine(new int[] { bottom2 }, new int[] { 0, 1 });
					}
					model2.setValueAt(tableRows[i][ii], i + top2, ii > 0 ? ii + 1 : ii);
				}
			}
		}
		if (prop.containsKey("jd2_ctq3")) {
			String[][] tableRows = TCTableUtil.getTableRows(form, "jd2_ctq3", colNames3);
			System.out.println(Arrays.deepToString(tableRows));
			for (int i = 0; i < tableRows.length; i++) {
				for (int ii = 0; ii < tableRows[0].length; ii++) {
					model2.setValueAt(tableRows[i][ii], i + bottom2 + 1, ii + 2);
				}
			}
		}

//		ScrollPane examineScrollPanel = new ScrollPane();
//		examineScrollPanel.add(examinePanel);
		JScrollPane examineScrollPanel = new JScrollPane(examinePanel);

		// ȷϵҼ˵
		menu.setVisible(false);
		addR = new JMenuItem("");
		addR.setEnabled(false);
		menu.add(addR);
		addR.addActionListener(addRow());
		insertR = new JMenuItem("");
		insertR.setEnabled(false);
		menu.add(insertR);
		insertR.addActionListener(insertRow());
		delR = new JMenuItem("ɾ");
		delR.setEnabled(false);
		menu.add(delR);
		delR.addActionListener(deleteRow());

		menu3.setVisible(false);
		addP = new JMenuItem("ͼƬ");
		addP.setEnabled(false);
		menu3.add(addP);
		addP.addActionListener(addPic());
		delP = new JMenuItem("ɾͼƬ");
		delP.setEnabled(false);
		menu3.add(delP);
		delP.addActionListener(delPic());
		addF = new JMenuItem("ϴļ");
		addF.setEnabled(false);
		menu3.add(addF);
		addF.addActionListener(addFile());
		delF = new JMenuItem("ɾļ");
		delF.setEnabled(false);
		menu3.add(delF);
		delF.addActionListener(delFile());

		// 鵥Ҽ˵
		menu2.setVisible(false);
		addR2 = new JMenuItem("");
		addR2.setEnabled(false);
		menu2.add(addR2);
		addR2.addActionListener(addRow2());
		insertR2 = new JMenuItem("");
		insertR2.setEnabled(false);
		menu2.add(insertR2);
		insertR2.addActionListener(insertRow2());
		delR2 = new JMenuItem("ɾ");
		delR2.setEnabled(false);
		menu2.add(delR2);
		delR2.addActionListener(deleteRow2());

		center.add("confirm", confirmPanel);
		center.add("examine", examineScrollPanel);

		root.add(buttons, BorderLayout.NORTH);
		root.add(center, BorderLayout.CENTER);
		this.add(menu);
		this.add(menu2);
		this.add(menu3);
		this.add(root, BorderLayout.CENTER);

		cl.show(center, "confirm");
	}

	private void initModel() {
		disableEdit = new ArrayList<>();// ༭
		general = new HashMap<String, int[]>();// Ҫдһ
		model.setValueAt("Ʒȷϵ", 0, 0);
		disableEdit.add("0,0");
		model.setValueAt("ύ", 0, 14);
		disableEdit.add("0,14");
		model.setValueAt("", 0, 16);
		disableEdit.add("0,16");
		model.setValueAt("׼", 0, 18);
		disableEdit.add("0,18");
		model.setValueAt("", 2, 0);
		disableEdit.add("2,0");
		model.setValueAt("Ͳз", 2, 2);
		disableEdit.add("2,2");
		general.put("jd2_bz", new int[] { 2, 14 });
		disableEdit.add("2,14");
		general.put("jd2_sh", new int[] { 2, 16 });
		disableEdit.add("2,16");
		general.put("jd2_pz", new int[] { 2, 18 });
		disableEdit.add("2,18");
		model.setValueAt("", 4, 0);
		disableEdit.add("4,0");
		general.put("creation_date", new int[] { 4, 2 });
		disableEdit.add("4,2");
		model.setValueAt("", 4, 5);
		disableEdit.add("4,5");
		general.put("owning_user", new int[] { 4, 7 });
		disableEdit.add("4,7");
		general.put("jd2_bzrq", new int[] { 4, 14 });
		disableEdit.add("4,14");
		general.put("jd2_shrq", new int[] { 4, 16 });
		disableEdit.add("4,16");
		general.put("jd2_pzrq", new int[] { 4, 18 });
		disableEdit.add("4,18");
		model.setValueAt("", 6, 0);
		disableEdit.add("6,0");
		general.put("jd2_ljm", new int[] { 6, 2 });
		general.put("jd2_ljywm", new int[] { 6, 5 });
		model.setValueAt("ͺ", 6, 8);
		disableEdit.add("6,8");
		general.put("jd2_xh", new int[] { 6, 10 });
		model.setValueAt("", 6, 14);
		disableEdit.add("6,14");
		fl = new JComboBox<String>();
		fl.setRenderer(new MyComboBoxRenderer());
		try {
			if (form.getTCProperty("jd2_fl") != null) {
				String[] items = form.getTCProperty("jd2_fl").getLOV().getListOfValues().getLOVDisplayValues();
				fl.addItem(" ");
				for (String s : items) {
					fl.addItem(s);
				}
				fl.setSelectedItem(form.getProperty("jd2_fl"));
				if ("".equals(form.getProperty("jd2_fl"))) {
					fl.setSelectedItem(" ");
				}
				model.setValueAt(fl, 6, 17);
			}

		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		model.setValueAt("ϱ", 7, 0);
		disableEdit.add("7,0");
		general.put("jd2_wlbm", new int[] { 7, 2 });
		model.setValueAt("", 7, 8);
		disableEdit.add("7,8");
		yssl = new JRadioPanel(new String[] { "3", "5", "10", "30" });
		model.setValueAt(yssl, 7, 10);
		model.setValueAt("״̬", 7, 14);
		disableEdit.add("7,14");
		zt = new JComboBox<String>();
		zt.setRenderer(new MyComboBoxRenderer());
		try {
			if (form.getTCProperty("jd2_zt") != null) {
				String[] items = form.getTCProperty("jd2_zt").getLOV().getListOfValues().getLOVDisplayValues();
				zt.addItem(" ");
				for (String s : items) {
					zt.addItem(s);
				}
				zt.setSelectedItem(form.getProperty("jd2_zt"));
				if ("".equals(form.getProperty("jd2_zt"))) {
					zt.setSelectedItem(" ");
				}
				model.setValueAt(zt, 7, 17);
			}

		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		model.setValueAt("Ʒȼ", 8, 0);
		disableEdit.add("8,0");
		bpdj = new JComboBox<String>();
		bpdj.setRenderer(new MyComboBoxRenderer());
		try {
			if (form.getTCProperty("jd2_bpdj") != null) {
				String[] items = form.getTCProperty("jd2_bpdj").getLOV().getListOfValues().getLOVDisplayValues();
				for (String s : items) {
					bpdj.addItem(s);
				}
				bpdj.setSelectedItem(form.getProperty("jd2_bpdj"));
				model.setValueAt(bpdj, 8, 2);
			}

		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		model.setValueAt("ο", 8, 8);
		disableEdit.add("8,8");
		model.setValueAt("jd2_ckwl", 8, 10);
		general.put("jd2_ckwl", new int[] { 8, 10 });
		model.setValueAt("ͼ", 9, 0);
		disableEdit.add("9,0");
		general.put("jd2_th", new int[] { 9, 2 });
		model.setValueAt("", 10, 0);
		disableEdit.add("10,0");
		general.put("jd2_gg", new int[] { 10, 2 });
		model.setValueAt("Ӧ", 11, 0);
		disableEdit.add("11,0");
		general.put("jd2_gys", new int[] { 11, 2 });
		model.setValueAt("ԭ", 9, 8);
		disableEdit.add("9,8");
		general.put("jd2_syyy", new int[] { 9, 10 });
		model.setValueAt("Ŀǰ׶", 12, 0);
		disableEdit.add("12,0");
		mqjd = new JCheckPanel(new String[] { "DV", "PV", "PR", "SR", "ֳ", "MP" });
		model.setValueAt(mqjd, 12, 2);

		model.setValueAt("No", top, 0);
		disableEdit.add(top + ",0");
		model.setValueAt("ߴ֤", top, 1);
		disableEdit.add(top + ",1");
		model.setValueAt("ݣ#Ʒ/ǻţ", top, 7);
		disableEdit.add(top + ",7");
		model.setValueAt("", top, 19);
		disableEdit.add(top + ",19");
		model.setValueAt("", top + 1, 1);
		disableEdit.add(top + 1 + ",1");
		model.setValueAt("Ϲ", top + 1, 5);
		model.setValueAt("¹", top + 1, 6);
		disableEdit.add(top + 1 + ",5");
		for (int i = 1; i < 11; i++) {
			model.setValueAt("#" + i, top + 1, i + 6);
			disableEdit.add(top + 1 + "," + (i + 6));
		}
		model.setValueAt("Min", top + 1, 17);
		disableEdit.add(top + 1 + ",17");
		model.setValueAt("Max", top + 1, 18);
		disableEdit.add(top + 1 + ",18");

		for (int i = top + 2; i <= bottom; i++) {
			model.setValueAt(i - 1 - top, i, 0);
			disableEdit.add(i + ",0");
			model.combine(new int[] { i }, new int[] { 2, 3, 4 });
			JComboBox<String> jgComBox = new JComboBox<String>();
			jgComBox.setRenderer(new MyComboBoxRenderer());
			for (Entry<String, String> entry : jgItems.entrySet()) {
				jgComBox.addItem(entry.getKey());
			}
			model.setValueAt(jgComBox, i, model.getColumnCount() - 1);
		}

		model.combine(new int[] { 0, 1 }, new int[] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 });
		model.combine(new int[] { 0, 1 }, new int[] { 14, 15 });
		model.combine(new int[] { 0, 1 }, new int[] { 16, 17 });
		model.combine(new int[] { 0, 1 }, new int[] { 18, 19 });
		model.combine(new int[] { 2, 3 }, new int[] { 0, 1 });
		model.combine(new int[] { 2, 3 }, new int[] { 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 });
		model.combine(new int[] { 2, 3 }, new int[] { 14, 15 });
		model.combine(new int[] { 2, 3 }, new int[] { 16, 17 });
		model.combine(new int[] { 2, 3 }, new int[] { 18, 19 });
		model.combine(new int[] { 4, 5 }, new int[] { 0, 1 });
		model.combine(new int[] { 4, 5 }, new int[] { 2, 3, 4 });
		model.combine(new int[] { 4, 5 }, new int[] { 5, 6 });
		model.combine(new int[] { 4, 5 }, new int[] { 7, 8, 9, 10, 11, 12, 13 });
		model.combine(new int[] { 4, 5 }, new int[] { 14, 15 });
		model.combine(new int[] { 4, 5 }, new int[] { 16, 17 });
		model.combine(new int[] { 4, 5 }, new int[] { 18, 19 });
		model.combine(new int[] { 6 }, new int[] { 0, 1 });
		model.combine(new int[] { 6 }, new int[] { 2, 3, 4 });
		model.combine(new int[] { 6 }, new int[] { 5, 6, 7 });
		model.combine(new int[] { 6 }, new int[] { 8, 9 });
		model.combine(new int[] { 6 }, new int[] { 10, 11, 12, 13 });
		model.combine(new int[] { 6 }, new int[] { 14, 15, 16 });
		model.combine(new int[] { 6 }, new int[] { 17, 18, 19 });
		model.combine(new int[] { 7 }, new int[] { 0, 1 });
		model.combine(new int[] { 7 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 7 }, new int[] { 8, 9 });
		model.combine(new int[] { 7 }, new int[] { 10, 11, 12, 13 });
		model.combine(new int[] { 7 }, new int[] { 14, 15, 16 });
		model.combine(new int[] { 7 }, new int[] { 17, 18, 19 });
		model.combine(new int[] { 8 }, new int[] { 0, 1 });
		model.combine(new int[] { 8 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 8 }, new int[] { 8, 9 });
		model.combine(new int[] { 8 }, new int[] { 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 });
		model.combine(new int[] { 9 }, new int[] { 0, 1 });
		model.combine(new int[] { 9 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 9, 10, 11 }, new int[] { 8, 9 });
		model.combine(new int[] { 9, 10, 11 }, new int[] { 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 });
		model.combine(new int[] { 10 }, new int[] { 0, 1 });
		model.combine(new int[] { 10 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 11 }, new int[] { 0, 1 });
		model.combine(new int[] { 11 }, new int[] { 2, 3, 4, 5, 6, 7 });
		model.combine(new int[] { 12 }, new int[] { 0, 1 });
		model.combine(new int[] { 12 }, new int[] { 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 });
		model.combine(new int[] { top, 1 }, new int[] { 0 });
		model.combine(new int[] { top }, new int[] { 1, 2, 3, 4, 5, 6 });
		model.combine(new int[] { top }, new int[] { 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18 });
		model.combine(new int[] { top, top + 1 }, new int[] { 19 });
		model.combine(new int[] { top + 1 }, new int[] { 1, 2, 3, 4 });
	}

	private void initModel3() {
		disableEdit3 = new ArrayList<>();// ༭
		general3 = new HashMap<String, int[]>();// Ҫдһ
		model3.setValueAt("ΪCTQĳߴǳҪ", 0, 0);// ӡײʼ
		disableEdit3.add(0 + ",0");
		model3.setValueAt("SPL Picture", 1, 0);
//		picMap.put("jd2_ypzp", new int[] { 2, 0 });
		picMap.put("user_data_1", new int[] { 2, 0 });
		disableEdit3.add(1 + ",0");
		model3.setValueAt("ע", 1, 4);
		disableEdit3.add(1 + ",4");
		model3.setValueAt("C/Time", 1, 5);
		disableEdit3.add(1 + ",5");
		model3.setValueAt("ע", 1, 6);
		disableEdit3.add(1 + ",6");
		model3.setValueAt("ȴ", 1, 7);
		disableEdit3.add(1 + ",7");
		model3.setValueAt("װ", 1, 8);
		disableEdit3.add(1 + ",8");
		model3.setValueAt("Լ챨", 1, 9);
		disableEdit3.add(1 + ",9");
		model3.setValueAt("ҵָ", 1, 12);
		disableEdit3.add(1 + ",12");
		model3.setValueAt("QCͼ", 1, 15);
		disableEdit3.add(1 + ",15");
		model3.setValueAt("ϰװǩ", 1, 18);
		disableEdit3.add(1 + ",18");
		general3.put("jd2_Ctime", new int[] { 2, 5 });
		general3.put("jd2_zs", new int[] { 2, 6 });
		general3.put("jd2_lq", new int[] { 2, 7 });
		general3.put("jd2_baoz", new int[] { 2, 8 });
//		fileMap.put("jd2_gfzjbg", new int[] { 2, 9 });
		fileMap.put("user_data_2", new int[] { 2, 9 });
		fileMap.put("jd2_gfzyzds", new int[] { 2, 12 });
		fileMap.put("jd2_gfqcgct", new int[] { 2, 15 });
		fileMap.put("jd2_wlbzjbq", new int[] { 2, 18 });
		model3.setValueAt("Shot/24Hr", 3, 5);
		disableEdit3.add(3 + ",5");
		model3.setValueAt("", 3, 6);
		disableEdit3.add(3 + ",6");
		general3.put("jd2_Shot24Hr", new int[] { 4, 5 });
		general3.put("jd2_d", new int[] { 4, 6 });
		model3.setValueAt("3D", 5, 4);
		disableEdit3.add(5 + ",4");
		model3.setValueAt("jd2_3Dzl", 5, 5);
		general3.put("jd2_3Dzl", new int[] { 5, 5 });
		model3.setValueAt("עܹ", 5, 7);
		disableEdit3.add(5 + ",7");
		model3.setValueAt("IQC׼챨", 5, 9);
		disableEdit3.add(5 + ",9");
		model3.setValueAt("Ա", 5, 12);
		disableEdit3.add(5 + ",12");
		model3.setValueAt("ʱ", 5, 15);
		disableEdit3.add(5 + ",15");
		model3.setValueAt("ģ߱ʶ", 5, 18);
		disableEdit3.add(5 + ",18");
		fileMap.put("jd2_zsgytj", new int[] { 6, 7 });
		fileMap.put("jd2_icqsjbg", new int[] { 6, 9 });
		fileMap.put("jd2_csbg", new int[] { 6, 12 });
		fileMap.put("jd2_czbg", new int[] { 6, 15 });
		fileMap.put("jd2_mjbs", new int[] { 6, 18 });
		model3.setValueAt("ʵ", 7, 4);
		disableEdit3.add(7 + ",4");
		general3.put("jd2_sczl", new int[] { 7, 5 });
		model3.setValueAt("IQCҵָ", 9, 4);
		disableEdit3.add(9 + ",4");
		fileMap.put("jd2_icqjyzds", new int[] { 10, 4 });
		model3.setValueAt("", 11, 12);
		disableEdit3.add(11 + ",12");
		jued = new JComboBox<String>();
		jued.setRenderer(new MyComboBoxRenderer());
		try {
			if (form.getTCProperty("jd2_jued") != null) {
				String[] items = form.getTCProperty("jd2_jued").getLOV().getListOfValues().getLOVDisplayValues();
				jued.addItem(" ");
				for (String s : items) {
					jued.addItem(s);
				}
				jued.setSelectedItem(form.getProperty("jd2_jued"));
				if ("".equals(form.getProperty("jd2_jued"))) {
					jued.setSelectedItem(" ");
				}
				model3.setValueAt(jued, 11, 15);
			}

		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		fileMap.put("jd2_qtbg", new int[] { 9, 7 });

		model3.combine(new int[] { 0 }, new int[] { 0, 1, 2, 3, 4, 5 });
		model3.combine(new int[] { 1 }, new int[] { 0, 1 });
		model3.combine(new int[] { 1 }, new int[] { 2, 3 });
		model3.combine(new int[] { 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 }, new int[] { 0, 1, 2, 3 });
		model3.combine(new int[] { 1, 2, 3, 4 }, new int[] { 4 });
		model3.combine(new int[] { 1 }, new int[] { 9, 10, 11 });
		model3.combine(new int[] { 1 }, new int[] { 12, 13, 14 });
		model3.combine(new int[] { 1 }, new int[] { 15, 16, 17 });
		model3.combine(new int[] { 1 }, new int[] { 18, 19 });
		model3.combine(new int[] { 3, 4 }, new int[] { 7, 8 });
		model3.combine(new int[] { 2, 3, 4 }, new int[] { 9, 10, 11 });
		model3.combine(new int[] { 2, 3, 4 }, new int[] { 12, 13, 14 });
		model3.combine(new int[] { 2, 3, 4 }, new int[] { 15, 16, 17 });
		model3.combine(new int[] { 2, 3, 4 }, new int[] { 18, 19 });
		model3.combine(new int[] { 5, 6 }, new int[] { 4 });
		model3.combine(new int[] { 7, 8 }, new int[] { 4 });
		model3.combine(new int[] { 5, 6 }, new int[] { 5 });
		model3.combine(new int[] { 7, 8 }, new int[] { 5 });
		model3.combine(new int[] { 5, 6, 7, 8 }, new int[] { 6 });
		model3.combine(new int[] { 5 }, new int[] { 7, 8 });
		model3.combine(new int[] { 5 }, new int[] { 9, 10, 11 });
		model3.combine(new int[] { 5 }, new int[] { 12, 13, 14 });
		model3.combine(new int[] { 5 }, new int[] { 15, 16, 17 });
		model3.combine(new int[] { 5 }, new int[] { 18, 19 });
		model3.combine(new int[] { 6, 7, 8 }, new int[] { 7, 8 });
		model3.combine(new int[] { 6, 7, 8 }, new int[] { 9, 10, 11 });
		model3.combine(new int[] { 6, 7, 8 }, new int[] { 12, 13, 14 });
		model3.combine(new int[] { 6, 7, 8 }, new int[] { 15, 16, 17 });
		model3.combine(new int[] { 6, 7, 8 }, new int[] { 18, 19 });
		model3.combine(new int[] { 9 }, new int[] { 4, 5, 6 });
		model3.combine(new int[] { 10, 11, 12 }, new int[] { 4, 5, 6 });
		model3.combine(new int[] { 9, 10, 11, 12 }, new int[] { 7, 8, 9, 10, 11 });
		model3.combine(new int[] { 9, 10 }, new int[] { 12, 13, 14, 15, 16, 17, 18, 19 });
		model3.combine(new int[] { 11, 12 }, new int[] { 12, 13, 14 });
		model3.combine(new int[] { 11, 12 }, new int[] { 15, 16, 17, 18, 19 });
	}

	@Override
	public void saveRendering() {
		// ͼƬ
		JLabel label = null;
		for (Entry<String, int[]> entry : picMap.entrySet()) {
			if (prop.containsKey(entry.getKey())) {
				System.out.println(entry.getKey());
				label = (JLabel) model3.getValueAt(entry.getValue()[0], entry.getValue()[1]);
				try {
					form.setProperty(entry.getKey(), label.getToolTipText() == null ? "" : label.getToolTipText());
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		}

		// ļ
		for (Entry<String, int[]> entry : fileMap.entrySet()) {
			if (prop.containsKey(entry.getKey())) {
				System.out.println(entry.getKey());
				label = (JLabel) model3.getValueAt(entry.getValue()[0], entry.getValue()[1]);
				try {
					form.setProperty(entry.getKey(), label.getToolTipText() == null ? "" : label.getToolTipText());
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		}

		// ѡ
		try {
			if (prop.containsKey("jd2_yssl")) {
				String value = yssl.getSelected() == null ? "" : yssl.getSelected().getText();
				if (form.getTCProperty("jd2_yssl").getLOV() != null && !"".equals(value)) {
					value = (String) form.getTCProperty("jd2_yssl").getLOV().getListOfValues().getRealValue(value);
				}
				form.setProperty("jd2_yssl", value);
			}
			if (prop.containsKey("jd2_mqjd")) {
				String value = mqjd.getSelectedText() == null ? "" : mqjd.getSelectedText();
				if (form.getTCProperty("jd2_mqjd").getLOV() != null && !"".equals(value)) {
					value = (String) form.getTCProperty("jd2_mqjd").getLOV().getListOfValues().getRealValue(value);
				}
				form.setProperty("jd2_mqjd", value);
			}
			if (prop.containsKey("jd2_bpdj")) {
				String value = bpdj.getSelectedItem() == null ? " " : bpdj.getSelectedItem().toString();
				if (form.getTCProperty("jd2_bpdj").getLOV() != null && !" ".equals(value)) {
					value = (String) form.getTCProperty("jd2_bpdj").getLOV().getListOfValues().getRealValue(value);
				}
				form.setProperty("jd2_bpdj", " ".equals(value) ? null : value);
			}
			if (prop.containsKey("jd2_fl")) {
				String value = fl.getSelectedItem() == null ? " " : fl.getSelectedItem().toString();
				if (form.getTCProperty("jd2_fl").getLOV() != null && !" ".equals(value)) {
					value = (String) form.getTCProperty("jd2_fl").getLOV().getListOfValues().getRealValue(value);
				}
				form.setProperty("jd2_fl", " ".equals(value) ? null : value);
			}
			if (prop.containsKey("jd2_zt")) {
				String value = zt.getSelectedItem() == null ? " " : zt.getSelectedItem().toString();
				if (form.getTCProperty("jd2_zt").getLOV() != null && !" ".equals(value)) {
					value = (String) form.getTCProperty("jd2_zt").getLOV().getListOfValues().getRealValue(value);
				}
				form.setProperty("jd2_zt", " ".equals(value) ? null : value);
			}
			if (prop.containsKey("jd2_jued")) {
				String value = jued.getSelectedItem() == null ? " " : jued.getSelectedItem().toString();
				if (form.getTCProperty("jd2_jued").getLOV() != null && !" ".equals(value)) {
					value = (String) form.getTCProperty("jd2_jued").getLOV().getListOfValues().getRealValue(value);
				}
				form.setProperty("jd2_jued", " ".equals(value) ? null : value);
			}

		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// ͨ
		for (Entry<String, int[]> entry : general.entrySet()) {
			try {
				if (prop.containsKey(entry.getKey())) {
					String value = model.getValueAt(entry.getValue()[0], entry.getValue()[1]).toString();
					if (form.getTCProperty(entry.getKey()).getLOV() != null && !"".equals(value)) {
						value = (String) form.getTCProperty(entry.getKey()).getLOV().getListOfValues()
								.getRealValue(value);
					}
					System.out.println(entry.getKey() + ":" + value);
					form.setProperty(entry.getKey(), value);
				}
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		for (Entry<String, int[]> entry : general3.entrySet()) {
			try {
				if (prop.containsKey(entry.getKey())) {
					String value = model3.getValueAt(entry.getValue()[0], entry.getValue()[1]).toString();
					if (form.getTCProperty(entry.getKey()).getLOV() != null && !"".equals(value)) {
						value = (String) form.getTCProperty(entry.getKey()).getLOV().getListOfValues()
								.getRealValue(value);
					}
					System.out.println(entry.getKey() + ":" + value);
					form.setProperty(entry.getKey(), value);
				}
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		// 
		if (prop.containsKey("jd2_ypqrdtable")) {
			List<String[]> data = new ArrayList<String[]>();
			int num = 0;
			while (model.getValueAt(top + 2 + num, 1) != null && !"".equals(model.getValueAt(top + 2 + num, 1))) {
				String[] row = new String[18];
				for (int ii = 0; ii < row.length; ii++) {
					Object object = model.getValueAt(top + 2 + num, ii > 2 ? ii + 2 : ii);
					if (ii == row.length - 1) {
						object = ((JComboBox<String>) object).getSelectedItem();
						row[ii] = object == null ? "" : jgItems.get(object.toString());
					} else {
						row[ii] = object == null ? "" : object.toString();
					}
				}
				data.add(row);
				num++;
				if (top + 2 + num > bottom) {
					break;
				}
			}
			String[][] dataArr = data.toArray(new String[data.size()][]);
			System.out.println(Arrays.deepToString(dataArr));
			TCTableUtil.setTableRows(form, "jd2_ypqrdtable", "JD2_YPQRDTABLE", colNames, dataArr);
		}
		if (prop.containsKey("jd2_ctq1")) {
			List<String[]> data = new ArrayList<String[]>();
			int num = 0;
			while (num < 3) {
				String[] row = new String[8];
				for (int ii = 0; ii < row.length; ii++) {
					Object object = model2.getValueAt(num + 1, ii + 2);
					if (object == null) {
						row[ii] = "";
					} else {
						row[ii] = object.toString();
					}
				}
				data.add(row);
				num++;
			}
			String[][] dataArr = data.toArray(new String[data.size()][]);
			System.out.println(Arrays.deepToString(dataArr));
			TCTableUtil.setTableRows(form, "jd2_ctq1", "JD2_CQT1", colNames1, dataArr);
		}
		if (prop.containsKey("jd2_ctq2")) {
			List<String[]> data = new ArrayList<String[]>();
			int num = 0;
			while (model2.getValueAt(top2 + num, 2) != null && !"".equals(model2.getValueAt(top2 + num, 2))) {
				String[] row = new String[9];
				for (int ii = 0; ii < row.length; ii++) {
					Object object = model2.getValueAt(top2 + num, ii > 0 ? ii + 1 : ii);
					if (object == null) {
						row[ii] = "";
					} else {
						row[ii] = object.toString();
					}
				}
				data.add(row);
				num++;
				if (top2 + num > bottom2) {
					break;
				}
			}
			String[][] dataArr = data.toArray(new String[data.size()][]);
			System.out.println(Arrays.deepToString(dataArr));
			TCTableUtil.setTableRows(form, "jd2_ctq2", "JD2_CQT2", colNames2, dataArr);
		}
		if (prop.containsKey("jd2_ctq3")) {
			List<String[]> data = new ArrayList<String[]>();
			int num = 0;
			while (num < end2 - 1) {
				String[] row = new String[8];
				for (int ii = 0; ii < row.length; ii++) {
					Object object = model2.getValueAt(bottom2 + 1 + num, ii + 2);
					if (object == null) {
						row[ii] = "";
					} else {
						row[ii] = object.toString();
					}
				}
				data.add(row);
				num++;
				if (bottom2 + 1 + num > model2.getRowCount()) {
					break;
				}
			}
			String[][] dataArr = data.toArray(new String[data.size()][]);
			System.out.println(Arrays.deepToString(dataArr));
			TCTableUtil.setTableRows(form, "jd2_ctq3", "JD2_CQT3", colNames3, dataArr);
		}

	}

	private ActionListener confirm() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				System.out.println("confirm");
				for (int i = 2; i < 10; i++) {
					for (int ii = 1; ii < 14; ii++) {
						String temp = table2.getValueAt(ii, i) == null ? "" : table2.getValueAt(ii, i).toString();
						table.setValueAt(temp, top + i, ii + 1 > 2 ? ii + 3 : ii + 1);
					}
				}
				for (int i = 2; i < 10; i++) {
					table.getColumnModel().getColumn(10).getCellEditor().getTableCellEditorComponent(table,
							table.getValueAt(top + i, 10), true, top + i, 10);
					table.getColumnModel().getColumn(10).getCellEditor().stopCellEditing();
				}
				table.revalidate();
				table.repaint();
				cl.show(center, "confirm");
			}
		};
		return actionListener;
	}

	private ActionListener examine() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				System.out.println("examine");
				for (int i = 1; i < 9; i++) {
					for (int ii = 2; ii < 15; ii++) {
						String temp = table.getValueAt(top + 1 + i, ii > 2 ? ii + 2 : ii) == null ? ""
								: table.getValueAt(top + 1 + i, ii > 2 ? ii + 2 : ii).toString();
						table2.setValueAt(temp, ii - 1, i + 1);
					}
				}
				for (int i = 2; i < 10; i++) {
					table2.getColumnModel().getColumn(i).getCellEditor().getTableCellEditorComponent(table2,
							table2.getValueAt(2, i), true, 2, i);
					table2.getColumnModel().getColumn(i).getCellEditor().stopCellEditing();
					table2.getColumnModel().getColumn(i).getCellEditor().getTableCellEditorComponent(table2,
							table2.getValueAt(3, i), true, 3, i);
					table2.getColumnModel().getColumn(i).getCellEditor().stopCellEditing();
					table2.getColumnModel().getColumn(i).getCellEditor().getTableCellEditorComponent(table2,
							table2.getValueAt(4, i), true, 4, i);
					table2.getColumnModel().getColumn(i).getCellEditor().stopCellEditing();
				}
				table2.revalidate();
				table2.repaint();
				cl.show(center, "examine");
			}
		};
		return actionListener;
	}

	private MouseAdapter rightClick() {
		MouseAdapter mouseAdapter = new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getButton() == MouseEvent.BUTTON3 && form.isCheckedOut() && table.getSelectedRow() != -1) {
					int row = table.getSelectedRow();
					boolean flag = (row >= top + 2 && row <= bottom);
					addR.setEnabled(flag);
					insertR.setEnabled(flag);
					delR.setEnabled(flag);
					menu.show(e.getComponent(), e.getX(), e.getY());
				}
			}
		};
		return mouseAdapter;
	}

	private MouseAdapter rightClick2() {
		MouseAdapter mouseAdapter = new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getButton() == MouseEvent.BUTTON3 && form.isCheckedOut() && table2.getSelectedRow() != -1) {
					int row = table2.getSelectedRow();
					boolean flag = (row >= top2 && row <= bottom2);
					addR2.setEnabled(flag);
					insertR2.setEnabled(flag);
					delR2.setEnabled(flag);
					menu2.show(e.getComponent(), e.getX(), e.getY());
				}
			}
		};
		return mouseAdapter;
	}

	private MouseAdapter rightClick3() {
		MouseAdapter mouseAdapter = new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getButton() == MouseEvent.BUTTON3 && form.isCheckedOut() && table3.getSelectedRow() != -1) {
					int row = table3.getSelectedRow();
					int col = table3.getSelectedColumn();
					boolean flag = false;
					for (Entry<String, int[]> entry : picMap.entrySet()) {
						if (entry.getValue()[0] == row && entry.getValue()[1] == col) {
							flag = true;
							break;
						}
					}
					addP.setEnabled(flag);
					delP.setEnabled(flag);
					flag = false;
					for (Entry<String, int[]> entry : fileMap.entrySet()) {
						if (entry.getValue()[0] == row && entry.getValue()[1] == col) {
							flag = true;
							break;
						}
					}
					addF.setEnabled(flag);
					delF.setEnabled(flag);
					menu3.show(e.getComponent(), e.getX(), e.getY());

				}
			}
		};
		return mouseAdapter;
	}

	private ActionListener addPic() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				JFileChooser fileChooser = new JFileChooser();
				fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				fileChooser.setMultiSelectionEnabled(false);
				fileChooser.setFileFilter(new FileFilter() {

					@Override
					public String getDescription() {
						// TODO Auto-generated method stub
						return "(ͼƬ)*.png;*.jpg;*.jpeg;*.bmp;";
					}

					@Override
					public boolean accept(File var1) {
						// TODO Auto-generated method stub
						return var1.getName().endsWith(".png") || var1.getName().endsWith(".jpg")
								|| var1.getName().endsWith(".jpeg") || var1.getName().endsWith(".bmp");
					}
				});
				fileChooser.showOpenDialog(menu);// ʾλ
				File file = fileChooser.getSelectedFile();
				if (file != null) {
					System.out.println("fileName:" + file.getName());
					String as1[] = { file.getPath() };// ļ·
					String as2[] = { "Image" };
					TCComponentDatasetType datasetType;
					try {
						datasetType = (TCComponentDatasetType) session.getTypeComponent("Dataset");
						TCComponentDataset dataset = datasetType.create(file.getName(), "", "Image");
						dataset.setFiles(as1, as2);
						TCComponent[] comps = form.getRelatedComponents();
						rev.add("IMAN_specification", dataset);
						String uid = dataset.getUid();
						System.out.println("uid:" + uid);
						ImageIcon icon = new ImageIcon(file.getPath());
						int row = table3.getSelectedRow();
						int col = table3.getSelectedColumn();
						String str = ((JLabel) model3.getValueAt(row, col)).getToolTipText();
						if (str != null && !"".equals(str)) {
							try {
								TCComponentDataset oldDataset = (TCComponentDataset) session.stringToComponent(str);
								rev.cutOperation("IMAN_specification", new TCComponent[] { oldDataset });
								oldDataset.delete();
							} catch (TCException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						int[] arr = model3.getSpan(row, col);
						System.out.println("row:" + arr[0] + ",col:" + arr[1]);
						icon.setImage(icon.getImage().getScaledInstance(
								table3.getColumnModel().getColumn(col).getPreferredWidth() * arr[1],
								table3.getRowHeight() * arr[0], Image.SCALE_SMOOTH));
						JLabel label = new JLabel();
						label.setLayout(new FlowLayout(FlowLayout.CENTER));
						label.setIcon(icon);
						label.addMouseListener(showImg(file.getPath()));
						label.setToolTipText(uid);
						model3.setValueAt(label, table3.getSelectedRow(), table3.getSelectedColumn());
						table3.revalidate();
						table3.repaint();
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			}
		};

		return actionListener;
	}

	private ActionListener delPic() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table3.getSelectedRow();
				int col = table3.getSelectedColumn();
				String uid = ((JLabel) model3.getValueAt(row, col)).getToolTipText();
				if (uid != null && !"".equals(uid)) {
					try {
						TCComponentDataset dataset = (TCComponentDataset) session.stringToComponent(uid);
						rev.cutOperation("IMAN_specification", new TCComponent[] { dataset });
						dataset.delete();
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
				((JLabel) model3.getValueAt(row, col)).setText("");
				table3.revalidate();
				table3.repaint();
			}

		};
		return actionListener;
	}

	private ActionListener addRow() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int num = Integer.parseInt(model.getValueAt(bottom, 0).toString());
				model.insertRow(++bottom);
				model.setValueAt(num + 1, bottom, 0);
				model.combine(new int[] { bottom }, new int[] { 2, 3, 4 });

				table.revalidate();
				table.repaint();
			}
		};
		return actionListener;
	}

	private ActionListener addRow2() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int num = Integer.parseInt(model2.getValueAt(bottom2, 0).toString());
				model2.insertRow(++bottom2);
				model2.setValueAt(num + 1, bottom2, 0);
				model2.combine(new int[] { bottom2 }, new int[] { 0, 1 });
				table2.revalidate();
				table2.repaint();
			}
		};
		return actionListener;
	}

	private ActionListener insertRow() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table.getSelectedRow();
				int num = Integer.parseInt(model.getValueAt(row, 0).toString());
				model.insertRow(row);
				bottom++;
				for (int i = row; i <= bottom; i++) {
					model.setValueAt(num + i - row, i, 0);
				}
				model.combine(new int[] { row }, new int[] { 2, 3, 4 });

				table.revalidate();
				table.repaint();
			}
		};
		return actionListener;
	}

	private ActionListener insertRow2() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table2.getSelectedRow();
				int num = Integer.parseInt(model2.getValueAt(row, 0).toString());
				model2.insertRow(row);
				bottom2++;
				for (int i = row; i <= bottom2; i++) {
					model2.setValueAt(num + i - row, i, 0);
				}
				model2.combine(new int[] { row }, new int[] { 0, 1 });
				table2.revalidate();
				table2.repaint();
			}
		};
		return actionListener;
	}

	private ActionListener deleteRow() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table.getSelectedRow();
				int num = Integer.parseInt(model.getValueAt(row, 0).toString());
				model.removeRow(row);
				bottom--;
				if (row <= bottom) {
					for (int i = row; i <= bottom; i++) {
						model.setValueAt(num + i - row, i, 0);
					}
				}

				table.revalidate();
				table.repaint();
			}
		};
		return actionListener;
	}

	private ActionListener deleteRow2() {
		ActionListener actionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table2.getSelectedRow();
				int num = Integer.parseInt(model2.getValueAt(row, 0).toString());
				model2.removeRow(row);
				bottom2--;
				if (row <= bottom2) {
					for (int i = row; i <= bottom2; i++) {
						model2.setValueAt(num + i - row, i, 0);
					}
				}
				table2.revalidate();
				table2.repaint();
			}
		};
		return actionListener;
	}

	private boolean isEditorDisable(List<String> list, int row, int col) {
		return list.contains(row + "," + col);
	}

	private MouseAdapter showImg(String path) {
		final String imagePath = path;
		MouseAdapter adapter = new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2) {
					PhotoFrame.getInstance(imagePath);
				}
			}
		};
		return adapter;
	}

	private MouseAdapter showFile(TCComponentDataset dataset) {
		MouseAdapter adapter = new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2) {
					try {
						dataset.open();
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			}
		};
		return adapter;
	}

	private ActionListener addFile() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				JFileChooser fileChooser = new JFileChooser();
				fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				fileChooser.setMultiSelectionEnabled(false);
				fileChooser.setFileFilter(new FileFilter() {

					@Override
					public String getDescription() {
						// TODO Auto-generated method stub
						return "(ĵͼƬ)*.doc;*.docx;*.xls;*.xlsx;*.png;*.jpg;*.jpeg;*.bmp;";
					}

					@Override
					public boolean accept(File var1) {
						// TODO Auto-generated method stub
						return var1.getName().endsWith(".doc") || var1.getName().endsWith(".docx")
								|| var1.getName().endsWith(".xls") || var1.getName().endsWith(".xlsx")
								|| var1.getName().endsWith(".png") || var1.getName().endsWith(".jpg")
								|| var1.getName().endsWith(".jpeg") || var1.getName().endsWith(".bmp");
					}
				});
				fileChooser.showOpenDialog(menu3);// ʾλ
				File file = fileChooser.getSelectedFile();
				if (file != null) {
					System.out.println("fileName:" + file.getName());
					String as1[] = { file.getPath() };// ļ·
					String as2[] = new String[1];
					String type = "";
					if (file.getName().endsWith(".doc")) {
						as2[0] = "word";
						type = "MSWord";
					} else if (file.getName().endsWith(".docx")) {
						as2[0] = "word";
						type = "MSWordX";
					} else if (file.getName().endsWith(".xls")) {
						as2[0] = "excel";
						type = "MSExcel";
					} else if (file.getName().endsWith(".xlsx")) {
						as2[0] = "excel";
						type = "MSExcelX";
					} else {
						as2[0] = "Image";
						type = "Image";
					}
					TCComponentDatasetType datasetType;
					try {
						datasetType = (TCComponentDatasetType) session.getTypeComponent("Dataset");
						TCComponentDataset dataset = datasetType.create(file.getName(), "", type);
						dataset.setFiles(as1, as2);
						TCComponent[] comps = form.getRelatedComponents();
						rev.add("IMAN_specification", dataset);
						String uid = dataset.getUid();
						System.out.println("uid:" + uid);
						int row = table3.getSelectedRow();
						int col = table3.getSelectedColumn();
						String str = ((JLabel) model3.getValueAt(row, col)).getToolTipText();
						if (str != null && !"".equals(str)) {
							try {
								TCComponentDataset oldDataset = (TCComponentDataset) session.stringToComponent(str);
								rev.cutOperation("IMAN_specification", new TCComponent[] { oldDataset });
								oldDataset.delete();
							} catch (TCException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						int[] arr = model3.getSpan(row, col);
						System.out.println("row:" + arr[0] + ",col:" + arr[1]);
						JLabel label = new JLabel();
						label.setLayout(new FlowLayout(FlowLayout.CENTER));
						label.setText(file.getName());
						label.setHorizontalAlignment(SwingConstants.CENTER);
						label.setForeground(new Color(0xff0078D7));
						label.addMouseListener(showFile(dataset));
						label.setToolTipText(uid);
						model3.setValueAt(label, table3.getSelectedRow(), table3.getSelectedColumn());
						table3.revalidate();
						table3.repaint();
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			}
		};
	}

	private ActionListener delFile() {
		return delPic();
	}
}
