package com.connor.jd.plm.table;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.SwingConstants;

public class MyComboBoxRenderer extends JLabel implements ListCellRenderer {
	public MyComboBoxRenderer() {
		setOpaque(true);
	}

	@Override
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected,
			boolean cellHasFocus) {
		setBackground(isSelected ? new Color(0xff0078D7) : Color.WHITE);
		setHorizontalAlignment(SwingConstants.CENTER);
		setText(value.toString());
		return this;
	}
}